import { d as sr, b as wn, C as Ce, f as lr, e as Sn, g as xn, h as Mn, i as ur, j as Ln, k as bn, l as An, m as Tn, n as On, o as Rn, q as De, r as En, E as yt, V as In, D as vt, S as Bn, u as Pn, t as Kn, v as ne, w as Nn, M as fr, x as Dn, y as Fn, z as _n, A as Hn, B as Vn, F as nr, G as Wn, H as $n, I as jn } from "./index-608e882c.js";
const ir = typeof String.prototype.normalize == "function" ? (c) => c.normalize("NFKD") : (c) => c;
class cr {
  /**
  Create a text cursor. The query is the search string, `from` to
  `to` provides the region to search.
  
  When `normalize` is given, it will be called, on both the query
  string and the content it is matched against, before comparing.
  You can, for example, create a case-insensitive search by
  passing `s => s.toLowerCase()`.
  
  Text is always normalized with
  [`.normalize("NFKD")`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/normalize)
  (when supported).
  */
  constructor(i, s, u = 0, d = i.length, m, x) {
    this.test = x, this.value = { from: 0, to: 0 }, this.done = !1, this.matches = [], this.buffer = "", this.bufferPos = 0, this.iter = i.iterRange(u, d), this.bufferStart = u, this.normalize = m ? (L) => m(ir(L)) : ir, this.query = this.normalize(s);
  }
  peek() {
    if (this.bufferPos == this.buffer.length) {
      if (this.bufferStart += this.buffer.length, this.iter.next(), this.iter.done)
        return -1;
      this.bufferPos = 0, this.buffer = this.iter.value;
    }
    return Sn(this.buffer, this.bufferPos);
  }
  /**
  Look for the next match. Updates the iterator's
  [`value`](https://codemirror.net/6/docs/ref/#search.SearchCursor.value) and
  [`done`](https://codemirror.net/6/docs/ref/#search.SearchCursor.done) properties. Should be called
  at least once before using the cursor.
  */
  next() {
    for (; this.matches.length; )
      this.matches.pop();
    return this.nextOverlapping();
  }
  /**
  The `next` method will ignore matches that partially overlap a
  previous match. This method behaves like `next`, but includes
  such matches.
  */
  nextOverlapping() {
    for (; ; ) {
      let i = this.peek();
      if (i < 0)
        return this.done = !0, this;
      let s = xn(i), u = this.bufferStart + this.bufferPos;
      this.bufferPos += Mn(i);
      let d = this.normalize(s);
      for (let m = 0, x = u; ; m++) {
        let L = d.charCodeAt(m), T = this.match(L, x);
        if (T)
          return this.value = T, this;
        if (m == d.length - 1)
          break;
        x == u && m < s.length && s.charCodeAt(m) == L && x++;
      }
    }
  }
  match(i, s) {
    let u = null;
    for (let d = 0; d < this.matches.length; d += 2) {
      let m = this.matches[d], x = !1;
      this.query.charCodeAt(m) == i && (m == this.query.length - 1 ? u = { from: this.matches[d + 1], to: s + 1 } : (this.matches[d]++, x = !0)), x || (this.matches.splice(d, 2), d -= 2);
    }
    return this.query.charCodeAt(0) == i && (this.query.length == 1 ? u = { from: s, to: s + 1 } : this.matches.push(1, s)), u && this.test && !this.test(u.from, u.to, this.buffer, this.bufferPos) && (u = null), u;
  }
}
typeof Symbol < "u" && (cr.prototype[Symbol.iterator] = function() {
  return this;
});
const hr = { from: -1, to: -1, match: /* @__PURE__ */ /.*/.exec("") }, mt = "gm" + (/x/.unicode == null ? "" : "u");
class Ct {
  /**
  Create a cursor that will search the given range in the given
  document. `query` should be the raw pattern (as you'd pass it to
  `new RegExp`).
  */
  constructor(i, s, u, d = 0, m = i.length) {
    if (this.text = i, this.to = m, this.curLine = "", this.done = !1, this.value = hr, /\\[sWDnr]|\n|\r|\[\^/.test(s))
      return new dr(i, s, u, d, m);
    this.re = new RegExp(s, mt + (u != null && u.ignoreCase ? "i" : "")), this.test = u == null ? void 0 : u.test, this.iter = i.iter();
    let x = i.lineAt(d);
    this.curLineStart = x.from, this.matchPos = Qe(i, d), this.getLine(this.curLineStart);
  }
  getLine(i) {
    this.iter.next(i), this.iter.lineBreak ? this.curLine = "" : (this.curLine = this.iter.value, this.curLineStart + this.curLine.length > this.to && (this.curLine = this.curLine.slice(0, this.to - this.curLineStart)), this.iter.next());
  }
  nextLine() {
    this.curLineStart = this.curLineStart + this.curLine.length + 1, this.curLineStart > this.to ? this.curLine = "" : this.getLine(0);
  }
  /**
  Move to the next match, if there is one.
  */
  next() {
    for (let i = this.matchPos - this.curLineStart; ; ) {
      this.re.lastIndex = i;
      let s = this.matchPos <= this.to && this.re.exec(this.curLine);
      if (s) {
        let u = this.curLineStart + s.index, d = u + s[0].length;
        if (this.matchPos = Qe(this.text, d + (u == d ? 1 : 0)), u == this.curLineStart + this.curLine.length && this.nextLine(), (u < d || u > this.value.to) && (!this.test || this.test(u, d, s)))
          return this.value = { from: u, to: d, match: s }, this;
        i = this.matchPos - this.curLineStart;
      } else if (this.curLineStart + this.curLine.length < this.to)
        this.nextLine(), i = 0;
      else
        return this.done = !0, this;
    }
  }
}
const ht = /* @__PURE__ */ new WeakMap();
class Oe {
  constructor(i, s) {
    this.from = i, this.text = s;
  }
  get to() {
    return this.from + this.text.length;
  }
  static get(i, s, u) {
    let d = ht.get(i);
    if (!d || d.from >= u || d.to <= s) {
      let L = new Oe(s, i.sliceString(s, u));
      return ht.set(i, L), L;
    }
    if (d.from == s && d.to == u)
      return d;
    let { text: m, from: x } = d;
    return x > s && (m = i.sliceString(s, x) + m, x = s), d.to < u && (m += i.sliceString(d.to, u)), ht.set(i, new Oe(x, m)), new Oe(s, m.slice(s - x, u - x));
  }
}
class dr {
  constructor(i, s, u, d, m) {
    this.text = i, this.to = m, this.done = !1, this.value = hr, this.matchPos = Qe(i, d), this.re = new RegExp(s, mt + (u != null && u.ignoreCase ? "i" : "")), this.test = u == null ? void 0 : u.test, this.flat = Oe.get(i, d, this.chunkEnd(
      d + 5e3
      /* Chunk.Base */
    ));
  }
  chunkEnd(i) {
    return i >= this.to ? this.to : this.text.lineAt(i).to;
  }
  next() {
    for (; ; ) {
      let i = this.re.lastIndex = this.matchPos - this.flat.from, s = this.re.exec(this.flat.text);
      if (s && !s[0] && s.index == i && (this.re.lastIndex = i + 1, s = this.re.exec(this.flat.text)), s) {
        let u = this.flat.from + s.index, d = u + s[0].length;
        if ((this.flat.to >= this.to || s.index + s[0].length <= this.flat.text.length - 10) && (!this.test || this.test(u, d, s)))
          return this.value = { from: u, to: d, match: s }, this.matchPos = Qe(this.text, d + (u == d ? 1 : 0)), this;
      }
      if (this.flat.to == this.to)
        return this.done = !0, this;
      this.flat = Oe.get(this.text, this.flat.from, this.chunkEnd(this.flat.from + this.flat.text.length * 2));
    }
  }
}
typeof Symbol < "u" && (Ct.prototype[Symbol.iterator] = dr.prototype[Symbol.iterator] = function() {
  return this;
});
function Un(c) {
  try {
    return new RegExp(c, mt), !0;
  } catch {
    return !1;
  }
}
function Qe(c, i) {
  if (i >= c.length)
    return i;
  let s = c.lineAt(i), u;
  for (; i < s.to && (u = s.text.charCodeAt(i - s.from)) >= 56320 && u < 57344; )
    i++;
  return i;
}
class Qn {
  /**
  Create a query object.
  */
  constructor(i) {
    this.search = i.search, this.caseSensitive = !!i.caseSensitive, this.literal = !!i.literal, this.regexp = !!i.regexp, this.replace = i.replace || "", this.valid = !!this.search && (!this.regexp || Un(this.search)), this.unquoted = this.unquote(this.search), this.wholeWord = !!i.wholeWord;
  }
  /**
  @internal
  */
  unquote(i) {
    return this.literal ? i : i.replace(/\\([nrt\\])/g, (s, u) => u == "n" ? `
` : u == "r" ? "\r" : u == "t" ? "	" : "\\");
  }
  /**
  Compare this query to another query.
  */
  eq(i) {
    return this.search == i.search && this.replace == i.replace && this.caseSensitive == i.caseSensitive && this.regexp == i.regexp && this.wholeWord == i.wholeWord;
  }
  /**
  @internal
  */
  create() {
    return this.regexp ? new Gn(this) : new zn(this);
  }
  /**
  Get a search cursor for this query, searching through the given
  range in the given state.
  */
  getCursor(i, s = 0, u) {
    let d = i.doc ? i : wn.create({ doc: i });
    return u == null && (u = d.doc.length), this.regexp ? Ae(this, d, s, u) : be(this, d, s, u);
  }
}
class vr {
  constructor(i) {
    this.spec = i;
  }
}
function be(c, i, s, u) {
  return new cr(i.doc, c.unquoted, s, u, c.caseSensitive ? void 0 : (d) => d.toLowerCase(), c.wholeWord ? Jn(i.doc, i.charCategorizer(i.selection.main.head)) : void 0);
}
function Jn(c, i) {
  return (s, u, d, m) => ((m > s || m + d.length < u) && (m = Math.max(0, s - 2), d = c.sliceString(m, Math.min(c.length, u + 2))), (i(Je(d, s - m)) != Ce.Word || i(ze(d, s - m)) != Ce.Word) && (i(ze(d, u - m)) != Ce.Word || i(Je(d, u - m)) != Ce.Word));
}
class zn extends vr {
  constructor(i) {
    super(i);
  }
  nextMatch(i, s, u) {
    let d = be(this.spec, i, u, i.doc.length).nextOverlapping();
    return d.done && (d = be(this.spec, i, 0, s).nextOverlapping()), d.done ? null : d.value;
  }
  // Searching in reverse is, rather than implementing inverted search
  // cursor, done by scanning chunk after chunk forward.
  prevMatchInRange(i, s, u) {
    for (let d = u; ; ) {
      let m = Math.max(s, d - 1e4 - this.spec.unquoted.length), x = be(this.spec, i, m, d), L = null;
      for (; !x.nextOverlapping().done; )
        L = x.value;
      if (L)
        return L;
      if (m == s)
        return null;
      d -= 1e4;
    }
  }
  prevMatch(i, s, u) {
    return this.prevMatchInRange(i, 0, s) || this.prevMatchInRange(i, u, i.doc.length);
  }
  getReplacement(i) {
    return this.spec.unquote(this.spec.replace);
  }
  matchAll(i, s) {
    let u = be(this.spec, i, 0, i.doc.length), d = [];
    for (; !u.next().done; ) {
      if (d.length >= s)
        return null;
      d.push(u.value);
    }
    return d;
  }
  highlight(i, s, u, d) {
    let m = be(this.spec, i, Math.max(0, s - this.spec.unquoted.length), Math.min(u + this.spec.unquoted.length, i.doc.length));
    for (; !m.next().done; )
      d(m.value.from, m.value.to);
  }
}
function Ae(c, i, s, u) {
  return new Ct(i.doc, c.search, {
    ignoreCase: !c.caseSensitive,
    test: c.wholeWord ? qn(i.charCategorizer(i.selection.main.head)) : void 0
  }, s, u);
}
function Je(c, i) {
  return c.slice(lr(c, i, !1), i);
}
function ze(c, i) {
  return c.slice(i, lr(c, i));
}
function qn(c) {
  return (i, s, u) => !u[0].length || (c(Je(u.input, u.index)) != Ce.Word || c(ze(u.input, u.index)) != Ce.Word) && (c(ze(u.input, u.index + u[0].length)) != Ce.Word || c(Je(u.input, u.index + u[0].length)) != Ce.Word);
}
class Gn extends vr {
  nextMatch(i, s, u) {
    let d = Ae(this.spec, i, u, i.doc.length).next();
    return d.done && (d = Ae(this.spec, i, 0, s).next()), d.done ? null : d.value;
  }
  prevMatchInRange(i, s, u) {
    for (let d = 1; ; d++) {
      let m = Math.max(
        s,
        u - d * 1e4
        /* FindPrev.ChunkSize */
      ), x = Ae(this.spec, i, m, u), L = null;
      for (; !x.next().done; )
        L = x.value;
      if (L && (m == s || L.from > m + 10))
        return L;
      if (m == s)
        return null;
    }
  }
  prevMatch(i, s, u) {
    return this.prevMatchInRange(i, 0, s) || this.prevMatchInRange(i, u, i.doc.length);
  }
  getReplacement(i) {
    return this.spec.unquote(this.spec.replace.replace(/\$([$&\d+])/g, (s, u) => u == "$" ? "$" : u == "&" ? i.match[0] : u != "0" && +u < i.match.length ? i.match[u] : s));
  }
  matchAll(i, s) {
    let u = Ae(this.spec, i, 0, i.doc.length), d = [];
    for (; !u.next().done; ) {
      if (d.length >= s)
        return null;
      d.push(u.value);
    }
    return d;
  }
  highlight(i, s, u, d) {
    let m = Ae(this.spec, i, Math.max(
      0,
      s - 250
      /* RegExp.HighlightMargin */
    ), Math.min(u + 250, i.doc.length));
    for (; !m.next().done; )
      d(m.value.from, m.value.to);
  }
}
const pt = /* @__PURE__ */ sr.define();
function Xn(c) {
  var i = c.Pos;
  function s(e, t) {
    var r = e.state.vim;
    if (!r || r.insertMode)
      return t.head;
    var n = r.sel.head;
    if (!n)
      return t.head;
    if (!(r.visualBlock && t.head.line != n.line))
      return t.from() == t.anchor && !t.empty() && t.head.line == n.line && t.head.ch != n.ch ? new i(t.head.line, t.head.ch - 1) : t.head;
  }
  function u(e, t, r) {
    if (t.line === r.line && t.ch >= r.ch - 1) {
      var n = e.getLine(t.line), a = n.charCodeAt(t.ch);
      55296 <= a && a <= 55551 && (r.ch += 1);
    }
    return { start: t, end: r };
  }
  var d = [
    // Key to key mapping. This goes first to make it possible to override
    // existing mappings.
    { keys: "<Left>", type: "keyToKey", toKeys: "h" },
    { keys: "<Right>", type: "keyToKey", toKeys: "l" },
    { keys: "<Up>", type: "keyToKey", toKeys: "k" },
    { keys: "<Down>", type: "keyToKey", toKeys: "j" },
    { keys: "g<Up>", type: "keyToKey", toKeys: "gk" },
    { keys: "g<Down>", type: "keyToKey", toKeys: "gj" },
    { keys: "<Space>", type: "keyToKey", toKeys: "l" },
    { keys: "<BS>", type: "keyToKey", toKeys: "h", context: "normal" },
    { keys: "<Del>", type: "keyToKey", toKeys: "x", context: "normal" },
    { keys: "<C-Space>", type: "keyToKey", toKeys: "W" },
    { keys: "<C-BS>", type: "keyToKey", toKeys: "B", context: "normal" },
    { keys: "<S-Space>", type: "keyToKey", toKeys: "w" },
    { keys: "<S-BS>", type: "keyToKey", toKeys: "b", context: "normal" },
    { keys: "<C-n>", type: "keyToKey", toKeys: "j" },
    { keys: "<C-p>", type: "keyToKey", toKeys: "k" },
    { keys: "<C-[>", type: "keyToKey", toKeys: "<Esc>" },
    { keys: "<C-c>", type: "keyToKey", toKeys: "<Esc>" },
    { keys: "<C-[>", type: "keyToKey", toKeys: "<Esc>", context: "insert" },
    { keys: "<C-c>", type: "keyToKey", toKeys: "<Esc>", context: "insert" },
    { keys: "<C-Esc>", type: "keyToKey", toKeys: "<Esc>" },
    // ipad keyboard sends C-Esc instead of C-[
    { keys: "<C-Esc>", type: "keyToKey", toKeys: "<Esc>", context: "insert" },
    { keys: "s", type: "keyToKey", toKeys: "cl", context: "normal" },
    { keys: "s", type: "keyToKey", toKeys: "c", context: "visual" },
    { keys: "S", type: "keyToKey", toKeys: "cc", context: "normal" },
    { keys: "S", type: "keyToKey", toKeys: "VdO", context: "visual" },
    { keys: "<Home>", type: "keyToKey", toKeys: "0" },
    { keys: "<End>", type: "keyToKey", toKeys: "$" },
    { keys: "<PageUp>", type: "keyToKey", toKeys: "<C-b>" },
    { keys: "<PageDown>", type: "keyToKey", toKeys: "<C-f>" },
    { keys: "<CR>", type: "keyToKey", toKeys: "j^", context: "normal" },
    { keys: "<Ins>", type: "keyToKey", toKeys: "i", context: "normal" },
    { keys: "<Ins>", type: "action", action: "toggleOverwrite", context: "insert" },
    // Motions
    { keys: "H", type: "motion", motion: "moveToTopLine", motionArgs: { linewise: !0, toJumplist: !0 } },
    { keys: "M", type: "motion", motion: "moveToMiddleLine", motionArgs: { linewise: !0, toJumplist: !0 } },
    { keys: "L", type: "motion", motion: "moveToBottomLine", motionArgs: { linewise: !0, toJumplist: !0 } },
    { keys: "h", type: "motion", motion: "moveByCharacters", motionArgs: { forward: !1 } },
    { keys: "l", type: "motion", motion: "moveByCharacters", motionArgs: { forward: !0 } },
    { keys: "j", type: "motion", motion: "moveByLines", motionArgs: { forward: !0, linewise: !0 } },
    { keys: "k", type: "motion", motion: "moveByLines", motionArgs: { forward: !1, linewise: !0 } },
    { keys: "gj", type: "motion", motion: "moveByDisplayLines", motionArgs: { forward: !0 } },
    { keys: "gk", type: "motion", motion: "moveByDisplayLines", motionArgs: { forward: !1 } },
    { keys: "w", type: "motion", motion: "moveByWords", motionArgs: { forward: !0, wordEnd: !1 } },
    { keys: "W", type: "motion", motion: "moveByWords", motionArgs: { forward: !0, wordEnd: !1, bigWord: !0 } },
    { keys: "e", type: "motion", motion: "moveByWords", motionArgs: { forward: !0, wordEnd: !0, inclusive: !0 } },
    { keys: "E", type: "motion", motion: "moveByWords", motionArgs: { forward: !0, wordEnd: !0, bigWord: !0, inclusive: !0 } },
    { keys: "b", type: "motion", motion: "moveByWords", motionArgs: { forward: !1, wordEnd: !1 } },
    { keys: "B", type: "motion", motion: "moveByWords", motionArgs: { forward: !1, wordEnd: !1, bigWord: !0 } },
    { keys: "ge", type: "motion", motion: "moveByWords", motionArgs: { forward: !1, wordEnd: !0, inclusive: !0 } },
    { keys: "gE", type: "motion", motion: "moveByWords", motionArgs: { forward: !1, wordEnd: !0, bigWord: !0, inclusive: !0 } },
    { keys: "{", type: "motion", motion: "moveByParagraph", motionArgs: { forward: !1, toJumplist: !0 } },
    { keys: "}", type: "motion", motion: "moveByParagraph", motionArgs: { forward: !0, toJumplist: !0 } },
    { keys: "(", type: "motion", motion: "moveBySentence", motionArgs: { forward: !1 } },
    { keys: ")", type: "motion", motion: "moveBySentence", motionArgs: { forward: !0 } },
    { keys: "<C-f>", type: "motion", motion: "moveByPage", motionArgs: { forward: !0 } },
    { keys: "<C-b>", type: "motion", motion: "moveByPage", motionArgs: { forward: !1 } },
    { keys: "<C-d>", type: "motion", motion: "moveByScroll", motionArgs: { forward: !0, explicitRepeat: !0 } },
    { keys: "<C-u>", type: "motion", motion: "moveByScroll", motionArgs: { forward: !1, explicitRepeat: !0 } },
    { keys: "gg", type: "motion", motion: "moveToLineOrEdgeOfDocument", motionArgs: { forward: !1, explicitRepeat: !0, linewise: !0, toJumplist: !0 } },
    { keys: "G", type: "motion", motion: "moveToLineOrEdgeOfDocument", motionArgs: { forward: !0, explicitRepeat: !0, linewise: !0, toJumplist: !0 } },
    { keys: "g$", type: "motion", motion: "moveToEndOfDisplayLine" },
    { keys: "g^", type: "motion", motion: "moveToStartOfDisplayLine" },
    { keys: "g0", type: "motion", motion: "moveToStartOfDisplayLine" },
    { keys: "0", type: "motion", motion: "moveToStartOfLine" },
    { keys: "^", type: "motion", motion: "moveToFirstNonWhiteSpaceCharacter" },
    { keys: "+", type: "motion", motion: "moveByLines", motionArgs: { forward: !0, toFirstChar: !0 } },
    { keys: "-", type: "motion", motion: "moveByLines", motionArgs: { forward: !1, toFirstChar: !0 } },
    { keys: "_", type: "motion", motion: "moveByLines", motionArgs: { forward: !0, toFirstChar: !0, repeatOffset: -1 } },
    { keys: "$", type: "motion", motion: "moveToEol", motionArgs: { inclusive: !0 } },
    { keys: "%", type: "motion", motion: "moveToMatchedSymbol", motionArgs: { inclusive: !0, toJumplist: !0 } },
    { keys: "f<character>", type: "motion", motion: "moveToCharacter", motionArgs: { forward: !0, inclusive: !0 } },
    { keys: "F<character>", type: "motion", motion: "moveToCharacter", motionArgs: { forward: !1 } },
    { keys: "t<character>", type: "motion", motion: "moveTillCharacter", motionArgs: { forward: !0, inclusive: !0 } },
    { keys: "T<character>", type: "motion", motion: "moveTillCharacter", motionArgs: { forward: !1 } },
    { keys: ";", type: "motion", motion: "repeatLastCharacterSearch", motionArgs: { forward: !0 } },
    { keys: ",", type: "motion", motion: "repeatLastCharacterSearch", motionArgs: { forward: !1 } },
    { keys: "'<character>", type: "motion", motion: "goToMark", motionArgs: { toJumplist: !0, linewise: !0 } },
    { keys: "`<character>", type: "motion", motion: "goToMark", motionArgs: { toJumplist: !0 } },
    { keys: "]`", type: "motion", motion: "jumpToMark", motionArgs: { forward: !0 } },
    { keys: "[`", type: "motion", motion: "jumpToMark", motionArgs: { forward: !1 } },
    { keys: "]'", type: "motion", motion: "jumpToMark", motionArgs: { forward: !0, linewise: !0 } },
    { keys: "['", type: "motion", motion: "jumpToMark", motionArgs: { forward: !1, linewise: !0 } },
    // the next two aren't motions but must come before more general motion declarations
    { keys: "]p", type: "action", action: "paste", isEdit: !0, actionArgs: { after: !0, isEdit: !0, matchIndent: !0 } },
    { keys: "[p", type: "action", action: "paste", isEdit: !0, actionArgs: { after: !1, isEdit: !0, matchIndent: !0 } },
    { keys: "]<character>", type: "motion", motion: "moveToSymbol", motionArgs: { forward: !0, toJumplist: !0 } },
    { keys: "[<character>", type: "motion", motion: "moveToSymbol", motionArgs: { forward: !1, toJumplist: !0 } },
    { keys: "|", type: "motion", motion: "moveToColumn" },
    { keys: "o", type: "motion", motion: "moveToOtherHighlightedEnd", context: "visual" },
    { keys: "O", type: "motion", motion: "moveToOtherHighlightedEnd", motionArgs: { sameLine: !0 }, context: "visual" },
    // Operators
    { keys: "d", type: "operator", operator: "delete" },
    { keys: "y", type: "operator", operator: "yank" },
    { keys: "c", type: "operator", operator: "change" },
    { keys: "=", type: "operator", operator: "indentAuto" },
    { keys: ">", type: "operator", operator: "indent", operatorArgs: { indentRight: !0 } },
    { keys: "<", type: "operator", operator: "indent", operatorArgs: { indentRight: !1 } },
    { keys: "g~", type: "operator", operator: "changeCase" },
    { keys: "gu", type: "operator", operator: "changeCase", operatorArgs: { toLower: !0 }, isEdit: !0 },
    { keys: "gU", type: "operator", operator: "changeCase", operatorArgs: { toLower: !1 }, isEdit: !0 },
    { keys: "n", type: "motion", motion: "findNext", motionArgs: { forward: !0, toJumplist: !0 } },
    { keys: "N", type: "motion", motion: "findNext", motionArgs: { forward: !1, toJumplist: !0 } },
    { keys: "gn", type: "motion", motion: "findAndSelectNextInclusive", motionArgs: { forward: !0 } },
    { keys: "gN", type: "motion", motion: "findAndSelectNextInclusive", motionArgs: { forward: !1 } },
    // Operator-Motion dual commands
    { keys: "x", type: "operatorMotion", operator: "delete", motion: "moveByCharacters", motionArgs: { forward: !0 }, operatorMotionArgs: { visualLine: !1 } },
    { keys: "X", type: "operatorMotion", operator: "delete", motion: "moveByCharacters", motionArgs: { forward: !1 }, operatorMotionArgs: { visualLine: !0 } },
    { keys: "D", type: "operatorMotion", operator: "delete", motion: "moveToEol", motionArgs: { inclusive: !0 }, context: "normal" },
    { keys: "D", type: "operator", operator: "delete", operatorArgs: { linewise: !0 }, context: "visual" },
    { keys: "Y", type: "operatorMotion", operator: "yank", motion: "expandToLine", motionArgs: { linewise: !0 }, context: "normal" },
    { keys: "Y", type: "operator", operator: "yank", operatorArgs: { linewise: !0 }, context: "visual" },
    { keys: "C", type: "operatorMotion", operator: "change", motion: "moveToEol", motionArgs: { inclusive: !0 }, context: "normal" },
    { keys: "C", type: "operator", operator: "change", operatorArgs: { linewise: !0 }, context: "visual" },
    { keys: "~", type: "operatorMotion", operator: "changeCase", motion: "moveByCharacters", motionArgs: { forward: !0 }, operatorArgs: { shouldMoveCursor: !0 }, context: "normal" },
    { keys: "~", type: "operator", operator: "changeCase", context: "visual" },
    { keys: "<C-u>", type: "operatorMotion", operator: "delete", motion: "moveToStartOfLine", context: "insert" },
    { keys: "<C-w>", type: "operatorMotion", operator: "delete", motion: "moveByWords", motionArgs: { forward: !1, wordEnd: !1 }, context: "insert" },
    //ignore C-w in normal mode
    { keys: "<C-w>", type: "idle", context: "normal" },
    // Actions
    { keys: "<C-i>", type: "action", action: "jumpListWalk", actionArgs: { forward: !0 } },
    { keys: "<C-o>", type: "action", action: "jumpListWalk", actionArgs: { forward: !1 } },
    { keys: "<C-e>", type: "action", action: "scroll", actionArgs: { forward: !0, linewise: !0 } },
    { keys: "<C-y>", type: "action", action: "scroll", actionArgs: { forward: !1, linewise: !0 } },
    { keys: "a", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "charAfter" }, context: "normal" },
    { keys: "A", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "eol" }, context: "normal" },
    { keys: "A", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "endOfSelectedArea" }, context: "visual" },
    { keys: "i", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "inplace" }, context: "normal" },
    { keys: "gi", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "lastEdit" }, context: "normal" },
    { keys: "I", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "firstNonBlank" }, context: "normal" },
    { keys: "gI", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "bol" }, context: "normal" },
    { keys: "I", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { insertAt: "startOfSelectedArea" }, context: "visual" },
    { keys: "o", type: "action", action: "newLineAndEnterInsertMode", isEdit: !0, interlaceInsertRepeat: !0, actionArgs: { after: !0 }, context: "normal" },
    { keys: "O", type: "action", action: "newLineAndEnterInsertMode", isEdit: !0, interlaceInsertRepeat: !0, actionArgs: { after: !1 }, context: "normal" },
    { keys: "v", type: "action", action: "toggleVisualMode" },
    { keys: "V", type: "action", action: "toggleVisualMode", actionArgs: { linewise: !0 } },
    { keys: "<C-v>", type: "action", action: "toggleVisualMode", actionArgs: { blockwise: !0 } },
    { keys: "<C-q>", type: "action", action: "toggleVisualMode", actionArgs: { blockwise: !0 } },
    { keys: "gv", type: "action", action: "reselectLastSelection" },
    { keys: "J", type: "action", action: "joinLines", isEdit: !0 },
    { keys: "gJ", type: "action", action: "joinLines", actionArgs: { keepSpaces: !0 }, isEdit: !0 },
    { keys: "p", type: "action", action: "paste", isEdit: !0, actionArgs: { after: !0, isEdit: !0 } },
    { keys: "P", type: "action", action: "paste", isEdit: !0, actionArgs: { after: !1, isEdit: !0 } },
    { keys: "r<character>", type: "action", action: "replace", isEdit: !0 },
    { keys: "@<character>", type: "action", action: "replayMacro" },
    { keys: "q<character>", type: "action", action: "enterMacroRecordMode" },
    // Handle Replace-mode as a special case of insert mode.
    { keys: "R", type: "action", action: "enterInsertMode", isEdit: !0, actionArgs: { replace: !0 }, context: "normal" },
    { keys: "R", type: "operator", operator: "change", operatorArgs: { linewise: !0, fullLine: !0 }, context: "visual", exitVisualBlock: !0 },
    { keys: "u", type: "action", action: "undo", context: "normal" },
    { keys: "u", type: "operator", operator: "changeCase", operatorArgs: { toLower: !0 }, context: "visual", isEdit: !0 },
    { keys: "U", type: "operator", operator: "changeCase", operatorArgs: { toLower: !1 }, context: "visual", isEdit: !0 },
    { keys: "<C-r>", type: "action", action: "redo" },
    { keys: "m<character>", type: "action", action: "setMark" },
    { keys: '"<character>', type: "action", action: "setRegister" },
    { keys: "<C-r><character>", type: "action", action: "insertRegister", context: "insert", isEdit: !0 },
    { keys: "zz", type: "action", action: "scrollToCursor", actionArgs: { position: "center" } },
    { keys: "z.", type: "action", action: "scrollToCursor", actionArgs: { position: "center" }, motion: "moveToFirstNonWhiteSpaceCharacter" },
    { keys: "zt", type: "action", action: "scrollToCursor", actionArgs: { position: "top" } },
    { keys: "z<CR>", type: "action", action: "scrollToCursor", actionArgs: { position: "top" }, motion: "moveToFirstNonWhiteSpaceCharacter" },
    { keys: "zb", type: "action", action: "scrollToCursor", actionArgs: { position: "bottom" } },
    { keys: "z-", type: "action", action: "scrollToCursor", actionArgs: { position: "bottom" }, motion: "moveToFirstNonWhiteSpaceCharacter" },
    { keys: ".", type: "action", action: "repeatLastEdit" },
    { keys: "<C-a>", type: "action", action: "incrementNumberToken", isEdit: !0, actionArgs: { increase: !0, backtrack: !1 } },
    { keys: "<C-x>", type: "action", action: "incrementNumberToken", isEdit: !0, actionArgs: { increase: !1, backtrack: !1 } },
    { keys: "<C-t>", type: "action", action: "indent", actionArgs: { indentRight: !0 }, context: "insert" },
    { keys: "<C-d>", type: "action", action: "indent", actionArgs: { indentRight: !1 }, context: "insert" },
    // Text object motions
    { keys: "a<character>", type: "motion", motion: "textObjectManipulation" },
    { keys: "i<character>", type: "motion", motion: "textObjectManipulation", motionArgs: { textObjectInner: !0 } },
    // Search
    { keys: "/", type: "search", searchArgs: { forward: !0, querySrc: "prompt", toJumplist: !0 } },
    { keys: "?", type: "search", searchArgs: { forward: !1, querySrc: "prompt", toJumplist: !0 } },
    { keys: "*", type: "search", searchArgs: { forward: !0, querySrc: "wordUnderCursor", wholeWordOnly: !0, toJumplist: !0 } },
    { keys: "#", type: "search", searchArgs: { forward: !1, querySrc: "wordUnderCursor", wholeWordOnly: !0, toJumplist: !0 } },
    { keys: "g*", type: "search", searchArgs: { forward: !0, querySrc: "wordUnderCursor", toJumplist: !0 } },
    { keys: "g#", type: "search", searchArgs: { forward: !1, querySrc: "wordUnderCursor", toJumplist: !0 } },
    // Ex command
    { keys: ":", type: "ex" }
  ], m = d.length, x = [
    { name: "colorscheme", shortName: "colo" },
    { name: "map" },
    { name: "imap", shortName: "im" },
    { name: "nmap", shortName: "nm" },
    { name: "vmap", shortName: "vm" },
    { name: "unmap" },
    { name: "write", shortName: "w" },
    { name: "undo", shortName: "u" },
    { name: "redo", shortName: "red" },
    { name: "set", shortName: "se" },
    { name: "setlocal", shortName: "setl" },
    { name: "setglobal", shortName: "setg" },
    { name: "sort", shortName: "sor" },
    { name: "substitute", shortName: "s", possiblyAsync: !0 },
    { name: "nohlsearch", shortName: "noh" },
    { name: "yank", shortName: "y" },
    { name: "delmarks", shortName: "delm" },
    { name: "registers", shortName: "reg", excludeFromCommandHistory: !0 },
    { name: "vglobal", shortName: "v" },
    { name: "delete", shortName: "d" },
    { name: "join", shortName: "j" },
    { name: "global", shortName: "g" }
  ];
  function L(e) {
    e.setOption("disableInput", !0), e.setOption("showCursorWhenSelecting", !1), c.signal(e, "vim-mode-change", { mode: "normal" }), e.on("cursorActivity", Yt), _e(e), c.on(e.getInputField(), "paste", pe(e));
  }
  function T(e) {
    e.setOption("disableInput", !1), e.off("cursorActivity", Yt), c.off(e.getInputField(), "paste", pe(e)), e.state.vim = null, je && clearTimeout(je);
  }
  function N(e, t) {
    this == c.keyMap.vim && (e.options.$customCursor = null, c.rmClass(e.getWrapperElement(), "cm-fat-cursor")), (!t || t.attach != W) && T(e);
  }
  function W(e, t) {
    this == c.keyMap.vim && (e.curOp && (e.curOp.selectionChanged = !0), e.options.$customCursor = s, c.addClass(e.getWrapperElement(), "cm-fat-cursor")), (!t || t.attach != W) && L(e);
  }
  c.defineOption("vimMode", !1, function(e, t, r) {
    t && e.getOption("keyMap") != "vim" ? e.setOption("keyMap", "vim") : !t && r != c.Init && /^vim/.test(e.getOption("keyMap")) && e.setOption("keyMap", "default");
  });
  function F(e, t) {
    if (t) {
      if (this[e])
        return this[e];
      var r = $(e);
      if (!r)
        return !1;
      var n = he.findKey(t, r);
      return typeof n == "function" && c.signal(t, "vim-keypress", r), n;
    }
  }
  var E = { Shift: "S", Ctrl: "C", Alt: "A", Cmd: "D", Mod: "A", CapsLock: "" }, _ = { Enter: "CR", Backspace: "BS", Delete: "Del", Insert: "Ins" };
  function $(e) {
    if (e.charAt(0) == "'")
      return e.charAt(1);
    var t = e.split(/-(?!$)/), r = t[t.length - 1];
    if (t.length == 1 && t[0].length == 1)
      return !1;
    if (t.length == 2 && t[0] == "Shift" && r.length == 1)
      return !1;
    for (var n = !1, a = 0; a < t.length; a++) {
      var o = t[a];
      o in E ? t[a] = E[o] : n = !0, o in _ && (t[a] = _[o]);
    }
    return n ? (Re(r) && (t[t.length - 1] = r.toLowerCase()), "<" + t.join("-") + ">") : !1;
  }
  function pe(e) {
    var t = e.state.vim;
    return t.onPasteFn || (t.onPasteFn = function() {
      t.insertMode || (e.setCursor(j(e.getCursor(), 0, 1)), Ie.enterInsertMode(e, {}, t));
    }), t.onPasteFn;
  }
  var xe = /[\d]/, ke = [c.isWordChar, function(e) {
    return e && !c.isWordChar(e) && !/\s/.test(e);
  }], ge = [function(e) {
    return /\S/.test(e);
  }];
  function Ge(e, t) {
    for (var r = [], n = e; n < e + t; n++)
      r.push(String.fromCharCode(n));
    return r;
  }
  var kt = Ge(65, 26), wt = Ge(97, 26), St = Ge(48, 10), Lr = [].concat(kt, wt, St, ["<", ">"]), xt = [].concat(kt, wt, St, ["-", '"', ".", ":", "_", "/", "+"]), Xe;
  try {
    Xe = new RegExp("^[\\p{Lu}]$", "u");
  } catch {
    Xe = /^[A-Z]$/;
  }
  function Ye(e, t) {
    return t >= e.firstLine() && t <= e.lastLine();
  }
  function Ze(e) {
    return /^[a-z]$/.test(e);
  }
  function br(e) {
    return "()[]{}".indexOf(e) != -1;
  }
  function Ar(e) {
    return xe.test(e);
  }
  function Re(e) {
    return Xe.test(e);
  }
  function ee(e) {
    return /^\s*$/.test(e);
  }
  function Me(e) {
    return ".?!".indexOf(e) != -1;
  }
  function et(e, t) {
    for (var r = 0; r < t.length; r++)
      if (t[r] == e)
        return !0;
    return !1;
  }
  var ce = {};
  function Fe(e, t, r, n, a) {
    if (t === void 0 && !a)
      throw Error("defaultValue is required unless callback is provided");
    if (r || (r = "string"), ce[e] = {
      type: r,
      defaultValue: t,
      callback: a
    }, n)
      for (var o = 0; o < n.length; o++)
        ce[n[o]] = ce[e];
    t && tt(e, t);
  }
  function tt(e, t, r, n) {
    var a = ce[e];
    n = n || {};
    var o = n.scope;
    if (!a)
      return new Error("Unknown option: " + e);
    if (a.type == "boolean") {
      if (t && t !== !0)
        return new Error("Invalid argument: " + e + "=" + t);
      t !== !1 && (t = !0);
    }
    a.callback ? (o !== "local" && a.callback(t, void 0), o !== "global" && r && a.callback(t, r)) : (o !== "local" && (a.value = a.type == "boolean" ? !!t : t), o !== "global" && r && (r.state.vim.options[e] = { value: t }));
  }
  function we(e, t, r) {
    var n = ce[e];
    r = r || {};
    var a = r.scope;
    if (!n)
      return new Error("Unknown option: " + e);
    if (n.callback) {
      var o = t && n.callback(void 0, t);
      return a !== "global" && o !== void 0 ? o : a !== "local" ? n.callback() : void 0;
    } else {
      var o = a !== "global" && t && t.state.vim.options[e];
      return (o || a !== "local" && n || {}).value;
    }
  }
  Fe("filetype", void 0, "string", ["ft"], function(e, t) {
    if (t !== void 0)
      if (e === void 0) {
        var r = t.getOption("mode");
        return r == "null" ? "" : r;
      } else {
        var r = e == "" ? "null" : e;
        t.setOption("mode", r);
      }
  });
  var Tr = function() {
    var e = 100, t = -1, r = 0, n = 0, a = new Array(e);
    function o(f, p, v) {
      var C = t % e, k = a[C];
      function g(S) {
        var w = ++t % e, b = a[w];
        b && b.clear(), a[w] = f.setBookmark(S);
      }
      if (k) {
        var y = k.find();
        y && !re(y, p) && g(p);
      } else
        g(p);
      g(v), r = t, n = t - e + 1, n < 0 && (n = 0);
    }
    function l(f, p) {
      t += p, t > r ? t = r : t < n && (t = n);
      var v = a[(e + t) % e];
      if (v && !v.find()) {
        var C = p > 0 ? 1 : -1, k, g = f.getCursor();
        do
          if (t += C, v = a[(e + t) % e], v && (k = v.find()) && !re(g, k))
            break;
        while (t < r && t > n);
      }
      return v;
    }
    function h(f, p) {
      var v = t, C = l(f, p);
      return t = v, C && C.find();
    }
    return {
      cachedCursor: void 0,
      //used for # and * jumps
      add: o,
      find: h,
      move: l
    };
  }, Mt = function(e) {
    return e ? {
      changes: e.changes,
      expectCursorActivityForChange: e.expectCursorActivityForChange
    } : {
      // Change list
      changes: [],
      // Set to true on change, false on cursorActivity.
      expectCursorActivityForChange: !1
    };
  };
  function Lt() {
    this.latestRegister = void 0, this.isPlaying = !1, this.isRecording = !1, this.replaySearchQueries = [], this.onRecordingDone = void 0, this.lastInsertModeChanges = Mt();
  }
  Lt.prototype = {
    exitMacroRecordMode: function() {
      var e = M.macroModeState;
      e.onRecordingDone && e.onRecordingDone(), e.onRecordingDone = void 0, e.isRecording = !1;
    },
    enterMacroRecordMode: function(e, t) {
      var r = M.registerController.getRegister(t);
      if (r) {
        if (r.clear(), this.latestRegister = t, e.openDialog) {
          var n = me("span", { class: "cm-vim-message" }, "recording @" + t);
          this.onRecordingDone = e.openDialog(n, null, { bottom: !0 });
        }
        this.isRecording = !0;
      }
    }
  };
  function _e(e) {
    return e.state.vim || (e.state.vim = {
      inputState: new He(),
      // Vim's input state that triggered the last edit, used to repeat
      // motions and operators with '.'.
      lastEditInputState: void 0,
      // Vim's action command before the last edit, used to repeat actions
      // with '.' and insert mode repeat.
      lastEditActionCommand: void 0,
      // When using jk for navigation, if you move from a longer line to a
      // shorter line, the cursor may clip to the end of the shorter line.
      // If j is pressed again and cursor goes to the next line, the
      // cursor should go back to its horizontal position on the longer
      // line if it can. This is to keep track of the horizontal position.
      lastHPos: -1,
      // Doing the same with screen-position for gj/gk
      lastHSPos: -1,
      // The last motion command run. Cleared if a non-motion command gets
      // executed in between.
      lastMotion: null,
      marks: {},
      insertMode: !1,
      // Repeat count for changes made in insert mode, triggered by key
      // sequences like 3,i. Only exists when insertMode is true.
      insertModeRepeat: void 0,
      visualMode: !1,
      // If we are in visual line mode. No effect if visualMode is false.
      visualLine: !1,
      visualBlock: !1,
      lastSelection: null,
      lastPastedText: null,
      sel: {},
      // Buffer-local/window-local values of vim options.
      options: {}
    }), e.state.vim;
  }
  var M;
  function bt() {
    M = {
      // The current search query.
      searchQuery: null,
      // Whether we are searching backwards.
      searchIsReversed: !1,
      // Replace part of the last substituted pattern
      lastSubstituteReplacePart: void 0,
      jumpList: Tr(),
      macroModeState: new Lt(),
      // Recording latest f, t, F or T motion command.
      lastCharacterSearch: { increment: 0, forward: !0, selectedCharacter: "" },
      registerController: new At({}),
      // search history buffer
      searchHistoryController: new rt(),
      // ex Command history buffer
      exCommandHistoryController: new rt()
    };
    for (var e in ce) {
      var t = ce[e];
      t.value = t.defaultValue;
    }
  }
  var Ee, he = {
    enterVimMode: L,
    leaveVimMode: T,
    buildKeyMap: function() {
    },
    // Testing hook, though it might be useful to expose the register
    // controller anyway.
    getRegisterController: function() {
      return M.registerController;
    },
    // Testing hook.
    resetVimGlobalState_: bt,
    // Testing hook.
    getVimGlobalState_: function() {
      return M;
    },
    // Testing hook.
    maybeInitVimState_: _e,
    suppressErrorLogging: !1,
    InsertModeKey: ut,
    map: function(e, t, r) {
      ue.map(e, t, r);
    },
    unmap: function(e, t) {
      return ue.unmap(e, t);
    },
    // Non-recursive map function.
    // NOTE: This will not create mappings to key maps that aren't present
    // in the default key map. See TODO at bottom of function.
    noremap: function(e, t, r) {
      function n(g) {
        return g ? [g] : ["normal", "insert", "visual"];
      }
      for (var a = n(r), o = d.length, l = m, h = [], f = o - l; f < o && a.length; f++) {
        var p = d[f];
        if (p.keys == t && (!r || !p.context || p.context === r) && p.type.substr(0, 2) !== "ex" && p.type.substr(0, 3) !== "key") {
          var v = {};
          for (var C in p)
            v[C] = p[C];
          v.keys = e, r && !v.context && (v.context = r), h.unshift(v);
          var k = n(p.context);
          a = a.filter(function(g) {
            return k.indexOf(g) === -1;
          });
        }
      }
      for (var v of h)
        this._mapCommand(v);
    },
    // Remove all user-defined mappings for the provided context.
    mapclear: function(e) {
      var t = d.length, r = m, n = d.slice(0, t - r);
      if (d = d.slice(t - r), e)
        for (var a = n.length - 1; a >= 0; a--) {
          var o = n[a];
          if (e !== o.context)
            if (o.context)
              this._mapCommand(o);
            else {
              var l = ["normal", "insert", "visual"];
              for (var h in l)
                if (l[h] !== e) {
                  var f = {};
                  for (var p in o)
                    f[p] = o[p];
                  f.context = l[h], this._mapCommand(f);
                }
            }
        }
    },
    // TODO: Expose setOption and getOption as instance methods. Need to decide how to namespace
    // them, or somehow make them work with the existing CodeMirror setOption/getOption API.
    setOption: tt,
    getOption: we,
    defineOption: Fe,
    defineEx: function(e, t, r) {
      if (!t)
        t = e;
      else if (e.indexOf(t) !== 0)
        throw new Error('(Vim.defineEx) "' + t + '" is not a prefix of "' + e + '", command not registered');
      qt[e] = r, ue.commandMap_[t] = { name: e, shortName: t, type: "api" };
    },
    handleKey: function(e, t, r) {
      var n = this.findKey(e, t, r);
      if (typeof n == "function")
        return n();
    },
    multiSelectHandleKey: Cn,
    /**
     * This is the outermost function called by CodeMirror, after keys have
     * been mapped to their Vim equivalents.
     *
     * Finds a command based on the key (and cached keys if there is a
     * multi-key sequence). Returns `undefined` if no key is matched, a noop
     * function if a partial match is found (multi-key), and a function to
     * execute the bound command if a a key is matched. The function always
     * returns true.
     */
    findKey: function(e, t, r) {
      var n = _e(e);
      function a() {
        var v = M.macroModeState;
        if (v.isRecording) {
          if (t == "q")
            return v.exitMacroRecordMode(), G(e), !0;
          r != "mapping" && gn(v, t);
        }
      }
      function o() {
        if (t == "<Esc>") {
          if (n.visualMode)
            oe(e);
          else if (n.insertMode)
            Pe(e);
          else
            return;
          return G(e), !0;
        }
      }
      function l(v) {
        for (var C; v; )
          C = /<\w+-.+?>|<\w+>|./.exec(v), t = C[0], v = v.substring(C.index + t.length), he.handleKey(e, t, "mapping");
      }
      function h() {
        if (o())
          return !0;
        n.inputState.keyBuffer.push(t);
        var v = n.inputState.keyBuffer.join(""), C = t.length == 1, k = Se.matchCommand(v, d, n.inputState, "insert"), g = n.inputState.changeQueue;
        if (k.type == "none")
          return G(e), !1;
        if (k.type == "partial") {
          if (Ee && window.clearTimeout(Ee), Ee = C && window.setTimeout(
            function() {
              n.insertMode && n.inputState.keyBuffer.length && G(e);
            },
            we("insertModeEscKeysTimeout")
          ), C) {
            var y = e.listSelections();
            (!g || g.removed.length != y.length) && (g = n.inputState.changeQueue = new Or()), g.inserted += t;
            for (var S = 0; S < y.length; S++) {
              var w = te(y[S].anchor, y[S].head), b = ye(y[S].anchor, y[S].head), O = e.getRange(w, e.state.overwrite ? j(b, 0, 1) : b);
              g.removed[S] = (g.removed[S] || "") + O;
            }
          }
          return !C;
        }
        if (Ee && window.clearTimeout(Ee), k.command && g) {
          for (var y = e.listSelections(), S = 0; S < y.length; S++) {
            var A = y[S].head;
            e.replaceRange(
              g.removed[S] || "",
              j(A, 0, -g.inserted.length),
              A,
              "+input"
            );
          }
          M.macroModeState.lastInsertModeChanges.changes.pop();
        }
        return k.command || G(e), k.command;
      }
      function f() {
        if (a() || o())
          return !0;
        n.inputState.keyBuffer.push(t);
        var v = n.inputState.keyBuffer.join("");
        if (/^[1-9]\d*$/.test(v))
          return !0;
        var C = /^(\d*)(.*)$/.exec(v);
        if (!C)
          return G(e), !1;
        var k = n.visualMode ? "visual" : "normal", g = C[2] || C[1];
        n.inputState.operatorShortcut && n.inputState.operatorShortcut.slice(-1) == g && (g = n.inputState.operatorShortcut);
        var y = Se.matchCommand(g, d, n.inputState, k);
        return y.type == "none" ? (G(e), !1) : y.type == "partial" ? !0 : y.type == "clear" ? (G(e), !0) : (n.inputState.keyBuffer.length = 0, C = /^(\d*)(.*)$/.exec(v), C[1] && C[1] != "0" && n.inputState.pushRepeatDigit(C[1]), y.command);
      }
      var p;
      return n.insertMode ? p = h() : p = f(), p === !1 ? !n.insertMode && t.length === 1 ? function() {
        return !0;
      } : void 0 : p === !0 ? function() {
        return !0;
      } : function() {
        return e.operation(function() {
          e.curOp.isVimOp = !0;
          try {
            p.type == "keyToKey" ? l(p.toKeys) : Se.processCommand(e, n, p);
          } catch (v) {
            throw e.state.vim = void 0, _e(e), he.suppressErrorLogging || console.log(v), v;
          }
          return !0;
        });
      };
    },
    handleEx: function(e, t) {
      ue.processCommand(e, t);
    },
    defineMotion: Er,
    defineAction: Br,
    defineOperator: Ir,
    mapCommand: vn,
    _mapCommand: Gt,
    defineRegister: Rr,
    exitVisualMode: oe,
    exitInsertMode: Pe
  };
  function He() {
    this.prefixRepeat = [], this.motionRepeat = [], this.operator = null, this.operatorArgs = null, this.motion = null, this.motionArgs = null, this.keyBuffer = [], this.registerName = null, this.changeQueue = null;
  }
  He.prototype.pushRepeatDigit = function(e) {
    this.operator ? this.motionRepeat = this.motionRepeat.concat(e) : this.prefixRepeat = this.prefixRepeat.concat(e);
  }, He.prototype.getRepeat = function() {
    var e = 0;
    return (this.prefixRepeat.length > 0 || this.motionRepeat.length > 0) && (e = 1, this.prefixRepeat.length > 0 && (e *= parseInt(this.prefixRepeat.join(""), 10)), this.motionRepeat.length > 0 && (e *= parseInt(this.motionRepeat.join(""), 10))), e;
  };
  function G(e, t) {
    e.state.vim.inputState = new He(), c.signal(e, "vim-command-done", t);
  }
  function Or() {
    this.removed = [], this.inserted = "";
  }
  function ae(e, t, r) {
    this.clear(), this.keyBuffer = [e || ""], this.insertModeChanges = [], this.searchQueries = [], this.linewise = !!t, this.blockwise = !!r;
  }
  ae.prototype = {
    setText: function(e, t, r) {
      this.keyBuffer = [e || ""], this.linewise = !!t, this.blockwise = !!r;
    },
    pushText: function(e, t) {
      t && (this.linewise || this.keyBuffer.push(`
`), this.linewise = !0), this.keyBuffer.push(e);
    },
    pushInsertModeChanges: function(e) {
      this.insertModeChanges.push(Mt(e));
    },
    pushSearchQuery: function(e) {
      this.searchQueries.push(e);
    },
    clear: function() {
      this.keyBuffer = [], this.insertModeChanges = [], this.searchQueries = [], this.linewise = !1;
    },
    toString: function() {
      return this.keyBuffer.join("");
    }
  };
  function Rr(e, t) {
    var r = M.registerController.registers;
    if (!e || e.length != 1)
      throw Error("Register name must be 1 character");
    if (r[e])
      throw Error("Register already defined " + e);
    r[e] = t, xt.push(e);
  }
  function At(e) {
    this.registers = e, this.unnamedRegister = e['"'] = new ae(), e["."] = new ae(), e[":"] = new ae(), e["/"] = new ae(), e["+"] = new ae();
  }
  At.prototype = {
    pushText: function(e, t, r, n, a) {
      if (e !== "_") {
        n && r.charAt(r.length - 1) !== `
` && (r += `
`);
        var o = this.isValidRegister(e) ? this.getRegister(e) : null;
        if (!o) {
          switch (t) {
            case "yank":
              this.registers[0] = new ae(r, n, a);
              break;
            case "delete":
            case "change":
              r.indexOf(`
`) == -1 ? this.registers["-"] = new ae(r, n) : (this.shiftNumericRegisters_(), this.registers[1] = new ae(r, n));
              break;
          }
          this.unnamedRegister.setText(r, n, a);
          return;
        }
        var l = Re(e);
        l ? o.pushText(r, n) : o.setText(r, n, a), e === "+" && navigator.clipboard.writeText(r), this.unnamedRegister.setText(o.toString(), n);
      }
    },
    // Gets the register named @name.  If one of @name doesn't already exist,
    // create it.  If @name is invalid, return the unnamedRegister.
    getRegister: function(e) {
      return this.isValidRegister(e) ? (e = e.toLowerCase(), this.registers[e] || (this.registers[e] = new ae()), this.registers[e]) : this.unnamedRegister;
    },
    isValidRegister: function(e) {
      return e && et(e, xt);
    },
    shiftNumericRegisters_: function() {
      for (var e = 9; e >= 2; e--)
        this.registers[e] = this.getRegister("" + (e - 1));
    }
  };
  function rt() {
    this.historyBuffer = [], this.iterator = 0, this.initialPrefix = null;
  }
  rt.prototype = {
    // the input argument here acts a user entered prefix for a small time
    // until we start autocompletion in which case it is the autocompleted.
    nextMatch: function(e, t) {
      var r = this.historyBuffer, n = t ? -1 : 1;
      this.initialPrefix === null && (this.initialPrefix = e);
      for (var a = this.iterator + n; t ? a >= 0 : a < r.length; a += n)
        for (var o = r[a], l = 0; l <= o.length; l++)
          if (this.initialPrefix == o.substring(0, l))
            return this.iterator = a, o;
      if (a >= r.length)
        return this.iterator = r.length, this.initialPrefix;
      if (a < 0)
        return e;
    },
    pushInput: function(e) {
      var t = this.historyBuffer.indexOf(e);
      t > -1 && this.historyBuffer.splice(t, 1), e.length && this.historyBuffer.push(e);
    },
    reset: function() {
      this.initialPrefix = null, this.iterator = this.historyBuffer.length;
    }
  };
  var Se = {
    matchCommand: function(e, t, r, n) {
      var a = Pr(e, t, n, r);
      if (!a.full && !a.partial)
        return { type: "none" };
      if (!a.full && a.partial)
        return { type: "partial" };
      for (var o, l = 0; l < a.full.length; l++) {
        var h = a.full[l];
        o || (o = h);
      }
      if (o.keys.slice(-11) == "<character>") {
        var f = Nr(e);
        if (!f || f.length > 1)
          return { type: "clear" };
        r.selectedCharacter = f;
      }
      return { type: "full", command: o };
    },
    processCommand: function(e, t, r) {
      switch (t.inputState.repeatOverride = r.repeatOverride, r.type) {
        case "motion":
          this.processMotion(e, t, r);
          break;
        case "operator":
          this.processOperator(e, t, r);
          break;
        case "operatorMotion":
          this.processOperatorMotion(e, t, r);
          break;
        case "action":
          this.processAction(e, t, r);
          break;
        case "search":
          this.processSearch(e, t, r);
          break;
        case "ex":
        case "keyToEx":
          this.processEx(e, t, r);
          break;
      }
    },
    processMotion: function(e, t, r) {
      t.inputState.motion = r.motion, t.inputState.motionArgs = Ve(r.motionArgs), this.evalInput(e, t);
    },
    processOperator: function(e, t, r) {
      var n = t.inputState;
      if (n.operator)
        if (n.operator == r.operator) {
          n.motion = "expandToLine", n.motionArgs = { linewise: !0 }, this.evalInput(e, t);
          return;
        } else
          G(e);
      n.operator = r.operator, n.operatorArgs = Ve(r.operatorArgs), r.keys.length > 1 && (n.operatorShortcut = r.keys), r.exitVisualBlock && (t.visualBlock = !1, Le(e)), t.visualMode && this.evalInput(e, t);
    },
    processOperatorMotion: function(e, t, r) {
      var n = t.visualMode, a = Ve(r.operatorMotionArgs);
      a && n && a.visualLine && (t.visualLine = !0), this.processOperator(e, t, r), n || this.processMotion(e, t, r);
    },
    processAction: function(e, t, r) {
      var n = t.inputState, a = n.getRepeat(), o = !!a, l = Ve(r.actionArgs) || {};
      n.selectedCharacter && (l.selectedCharacter = n.selectedCharacter), r.operator && this.processOperator(e, t, r), r.motion && this.processMotion(e, t, r), (r.motion || r.operator) && this.evalInput(e, t), l.repeat = a || 1, l.repeatIsExplicit = o, l.registerName = n.registerName, G(e), t.lastMotion = null, r.isEdit && this.recordLastEdit(t, n, r), Ie[r.action](e, l, t);
    },
    processSearch: function(e, t, r) {
      if (!e.getSearchCursor)
        return;
      var n = r.searchArgs.forward, a = r.searchArgs.wholeWordOnly;
      le(e).setReversed(!n);
      var o = n ? "/" : "?", l = le(e).getQuery(), h = e.getScrollInfo();
      function f(w, b, O) {
        M.searchHistoryController.pushInput(w), M.searchHistoryController.reset();
        try {
          Be(e, w, b, O);
        } catch {
          K(e, "Invalid regex: " + w), G(e);
          return;
        }
        Se.processMotion(e, t, {
          type: "motion",
          motion: "findNext",
          motionArgs: { forward: !0, toJumplist: r.searchArgs.toJumplist }
        });
      }
      function p(w) {
        e.scrollTo(h.left, h.top), f(
          w,
          !0,
          !0
          /** smartCase */
        );
        var b = M.macroModeState;
        b.isRecording && mn(b, w);
      }
      function v(w, b, O) {
        var A = c.keyName(w), B, U;
        A == "Up" || A == "Down" ? (B = A == "Up", U = w.target ? w.target.selectionEnd : 0, b = M.searchHistoryController.nextMatch(b, B) || "", O(b), U && w.target && (w.target.selectionEnd = w.target.selectionStart = Math.min(U, w.target.value.length))) : A != "Left" && A != "Right" && A != "Ctrl" && A != "Alt" && A != "Shift" && M.searchHistoryController.reset();
        var V;
        try {
          V = Be(
            e,
            b,
            !0,
            !0
            /** smartCase */
          );
        } catch {
        }
        V ? e.scrollIntoView(Qt(e, !n, V), 30) : (st(e), e.scrollTo(h.left, h.top));
      }
      function C(w, b, O) {
        var A = c.keyName(w);
        A == "Esc" || A == "Ctrl-C" || A == "Ctrl-[" || A == "Backspace" && b == "" ? (M.searchHistoryController.pushInput(b), M.searchHistoryController.reset(), Be(e, l), st(e), e.scrollTo(h.left, h.top), c.e_stop(w), G(e), O(), e.focus()) : A == "Up" || A == "Down" ? c.e_stop(w) : A == "Ctrl-U" && (c.e_stop(w), O(""));
      }
      switch (r.searchArgs.querySrc) {
        case "prompt":
          var k = M.macroModeState;
          if (k.isPlaying) {
            var S = k.replaySearchQueries.shift();
            f(
              S,
              !0,
              !1
              /** smartCase */
            );
          } else
            $e(e, {
              onClose: p,
              prefix: o,
              desc: "(JavaScript regexp)",
              onKeyUp: v,
              onKeyDown: C
            });
          break;
        case "wordUnderCursor":
          var g = We(
            e,
            !1,
            !1,
            !1,
            !0
            /** noSymbol */
          ), y = !0;
          if (g || (g = We(
            e,
            !1,
            !1,
            !1,
            !1
            /** noSymbol */
          ), y = !1), !g)
            return;
          var S = e.getLine(g.start.line).substring(
            g.start.ch,
            g.end.ch
          );
          y && a ? S = "\\b" + S + "\\b" : S = Dr(S), M.jumpList.cachedCursor = e.getCursor(), e.setCursor(g.start), f(
            S,
            !0,
            !1
            /** smartCase */
          );
          break;
      }
    },
    processEx: function(e, t, r) {
      function n(o) {
        M.exCommandHistoryController.pushInput(o), M.exCommandHistoryController.reset(), ue.processCommand(e, o), e.state.vim && G(e);
      }
      function a(o, l, h) {
        var f = c.keyName(o), p, v;
        (f == "Esc" || f == "Ctrl-C" || f == "Ctrl-[" || f == "Backspace" && l == "") && (M.exCommandHistoryController.pushInput(l), M.exCommandHistoryController.reset(), c.e_stop(o), G(e), h(), e.focus()), f == "Up" || f == "Down" ? (c.e_stop(o), p = f == "Up", v = o.target ? o.target.selectionEnd : 0, l = M.exCommandHistoryController.nextMatch(l, p) || "", h(l), v && o.target && (o.target.selectionEnd = o.target.selectionStart = Math.min(v, o.target.value.length))) : f == "Ctrl-U" ? (c.e_stop(o), h("")) : f != "Left" && f != "Right" && f != "Ctrl" && f != "Alt" && f != "Shift" && M.exCommandHistoryController.reset();
      }
      r.type == "keyToEx" ? ue.processCommand(e, r.exArgs.input) : t.visualMode ? $e(e, {
        onClose: n,
        prefix: ":",
        value: "'<,'>",
        onKeyDown: a,
        selectValueOnOpen: !1
      }) : $e(e, {
        onClose: n,
        prefix: ":",
        onKeyDown: a
      });
    },
    evalInput: function(e, t) {
      var r = t.inputState, n = r.motion, a = r.motionArgs || {}, o = r.operator, l = r.operatorArgs || {}, h = r.registerName, f = t.sel, p = D(t.visualMode ? X(e, f.head) : e.getCursor("head")), v = D(t.visualMode ? X(e, f.anchor) : e.getCursor("anchor")), C = D(p), k = D(v), g, y, S;
      if (o && this.recordLastEdit(t, r), r.repeatOverride !== void 0 ? S = r.repeatOverride : S = r.getRepeat(), S > 0 && a.explicitRepeat ? a.repeatIsExplicit = !0 : (a.noRepeat || !a.explicitRepeat && S === 0) && (S = 1, a.repeatIsExplicit = !1), r.selectedCharacter && (a.selectedCharacter = l.selectedCharacter = r.selectedCharacter), a.repeat = S, G(e), n) {
        var w = de[n](e, p, a, t, r);
        if (t.lastMotion = de[n], !w)
          return;
        if (a.toJumplist) {
          var b = M.jumpList, O = b.cachedCursor;
          O ? (Pt(e, O, w), delete b.cachedCursor) : Pt(e, p, w);
        }
        w instanceof Array ? (y = w[0], g = w[1]) : g = w, g || (g = D(p)), t.visualMode ? (t.visualBlock && g.ch === 1 / 0 || (g = X(e, g, C)), y && (y = X(e, y)), y = y || k, f.anchor = y, f.head = g, Le(e), ve(
          e,
          t,
          "<",
          H(y, g) ? y : g
        ), ve(
          e,
          t,
          ">",
          H(y, g) ? g : y
        )) : o || (g = X(e, g, C), e.setCursor(g.line, g.ch));
      }
      if (o) {
        if (l.lastSel) {
          y = k;
          var A = l.lastSel, B = Math.abs(A.head.line - A.anchor.line), U = Math.abs(A.head.ch - A.anchor.ch);
          A.visualLine ? g = new i(k.line + B, k.ch) : A.visualBlock ? g = new i(k.line + B, k.ch + U) : A.head.line == A.anchor.line ? g = new i(k.line, k.ch + U) : g = new i(k.line + B, k.ch), t.visualMode = !0, t.visualLine = A.visualLine, t.visualBlock = A.visualBlock, f = t.sel = {
            anchor: y,
            head: g
          }, Le(e);
        } else
          t.visualMode && (l.lastSel = {
            anchor: D(f.anchor),
            head: D(f.head),
            visualBlock: t.visualBlock,
            visualLine: t.visualLine
          });
        var V, z, P, R, q;
        if (t.visualMode) {
          V = te(f.head, f.anchor), z = ye(f.head, f.anchor), P = t.visualLine || l.linewise, R = t.visualBlock ? "block" : P ? "line" : "char";
          var Z = u(e, V, z);
          if (q = at(e, {
            anchor: Z.start,
            head: Z.end
          }, R), P) {
            var Q = q.ranges;
            if (R == "block")
              for (var fe = 0; fe < Q.length; fe++)
                Q[fe].head.ch = J(e, Q[fe].head.line);
            else
              R == "line" && (Q[0].head = new i(Q[0].head.line + 1, 0));
          }
        } else {
          if (V = D(y || k), z = D(g || C), H(z, V)) {
            var Ke = V;
            V = z, z = Ke;
          }
          P = a.linewise || l.linewise, P ? jr(e, V, z) : a.forward && $r(e, V, z), R = "char";
          var kn = !a.inclusive || P, Z = u(e, V, z);
          q = at(e, {
            anchor: Z.start,
            head: Z.end
          }, R, kn);
        }
        e.setSelections(q.ranges, q.primary), t.lastMotion = null, l.repeat = S, l.registerName = h, l.linewise = P;
        var ct = nt[o](
          e,
          l,
          q.ranges,
          k,
          g
        );
        t.visualMode && oe(e, ct != null), ct && e.setCursor(ct);
      }
    },
    recordLastEdit: function(e, t, r) {
      var n = M.macroModeState;
      n.isPlaying || (e.lastEditInputState = t, e.lastEditActionCommand = r, n.lastInsertModeChanges.changes = [], n.lastInsertModeChanges.expectCursorActivityForChange = !1, n.lastInsertModeChanges.visualBlock = e.visualBlock ? e.sel.head.line - e.sel.anchor.line : 0);
    }
  }, de = {
    moveToTopLine: function(e, t, r) {
      var n = lt(e).top + r.repeat - 1;
      return new i(n, se(e.getLine(n)));
    },
    moveToMiddleLine: function(e) {
      var t = lt(e), r = Math.floor((t.top + t.bottom) * 0.5);
      return new i(r, se(e.getLine(r)));
    },
    moveToBottomLine: function(e, t, r) {
      var n = lt(e).bottom - r.repeat + 1;
      return new i(n, se(e.getLine(n)));
    },
    expandToLine: function(e, t, r) {
      var n = t;
      return new i(n.line + r.repeat - 1, 1 / 0);
    },
    findNext: function(e, t, r) {
      var n = le(e), a = n.getQuery();
      if (a) {
        var o = !r.forward;
        return o = n.isReversed() ? !o : o, Ut(e, a), Qt(e, o, a, r.repeat);
      }
    },
    /**
     * Find and select the next occurrence of the search query. If the cursor is currently
     * within a match, then find and select the current match. Otherwise, find the next occurrence in the
     * appropriate direction.
     *
     * This differs from `findNext` in the following ways:
     *
     * 1. Instead of only returning the "from", this returns a "from", "to" range.
     * 2. If the cursor is currently inside a search match, this selects the current match
     *    instead of the next match.
     * 3. If there is no associated operator, this will turn on visual mode.
     */
    findAndSelectNextInclusive: function(e, t, r, n, a) {
      var o = le(e), l = o.getQuery();
      if (l) {
        var h = !r.forward;
        h = o.isReversed() ? !h : h;
        var f = cn(e, h, l, r.repeat, n);
        if (f) {
          if (a.operator)
            return f;
          var p = f[0], v = new i(f[1].line, f[1].ch - 1);
          if (n.visualMode) {
            (n.visualLine || n.visualBlock) && (n.visualLine = !1, n.visualBlock = !1, c.signal(e, "vim-mode-change", { mode: "visual", subMode: "" }));
            var C = n.sel.anchor;
            if (C)
              return o.isReversed() ? r.forward ? [C, p] : [C, v] : r.forward ? [C, v] : [C, p];
          } else
            n.visualMode = !0, n.visualLine = !1, n.visualBlock = !1, c.signal(e, "vim-mode-change", { mode: "visual", subMode: "" });
          return h ? [v, p] : [p, v];
        }
      }
    },
    goToMark: function(e, t, r, n) {
      var a = Ue(e, n, r.selectedCharacter);
      return a ? r.linewise ? { line: a.line, ch: se(e.getLine(a.line)) } : a : null;
    },
    moveToOtherHighlightedEnd: function(e, t, r, n) {
      if (n.visualBlock && r.sameLine) {
        var a = n.sel;
        return [
          X(e, new i(a.anchor.line, a.head.ch)),
          X(e, new i(a.head.line, a.anchor.ch))
        ];
      } else
        return [n.sel.head, n.sel.anchor];
    },
    jumpToMark: function(e, t, r, n) {
      for (var a = t, o = 0; o < r.repeat; o++) {
        var l = a;
        for (var h in n.marks)
          if (Ze(h)) {
            var f = n.marks[h].find(), p = r.forward ? H(f, l) : H(l, f);
            if (!p && !(r.linewise && f.line == l.line)) {
              var v = re(l, a), C = r.forward ? Rt(l, f, a) : Rt(a, f, l);
              (v || C) && (a = f);
            }
          }
      }
      return r.linewise && (a = new i(a.line, se(e.getLine(a.line)))), a;
    },
    moveByCharacters: function(e, t, r) {
      var n = t, a = r.repeat, o = r.forward ? n.ch + a : n.ch - a;
      return new i(n.line, o);
    },
    moveByLines: function(e, t, r, n) {
      var a = t, o = a.ch;
      switch (n.lastMotion) {
        case this.moveByLines:
        case this.moveByDisplayLines:
        case this.moveByScroll:
        case this.moveToColumn:
        case this.moveToEol:
          o = n.lastHPos;
          break;
        default:
          n.lastHPos = o;
      }
      var l = r.repeat + (r.repeatOffset || 0), h = r.forward ? a.line + l : a.line - l, f = e.firstLine(), p = e.lastLine(), v = e.findPosV(a, r.forward ? l : -l, "line", n.lastHSPos), C = r.forward ? v.line > h : v.line < h;
      return C && (h = v.line, o = v.ch), h < f && a.line == f ? this.moveToStartOfLine(e, t, r, n) : h > p && a.line == p ? Dt(e, t, r, n, !0) : (r.toFirstChar && (o = se(e.getLine(h)), n.lastHPos = o), n.lastHSPos = e.charCoords(new i(h, o), "div").left, new i(h, o));
    },
    moveByDisplayLines: function(e, t, r, n) {
      var a = t;
      switch (n.lastMotion) {
        case this.moveByDisplayLines:
        case this.moveByScroll:
        case this.moveByLines:
        case this.moveToColumn:
        case this.moveToEol:
          break;
        default:
          n.lastHSPos = e.charCoords(a, "div").left;
      }
      var o = r.repeat, l = e.findPosV(a, r.forward ? o : -o, "line", n.lastHSPos);
      if (l.hitSide)
        if (r.forward)
          var h = e.charCoords(l, "div"), f = { top: h.top + 8, left: n.lastHSPos }, l = e.coordsChar(f, "div");
        else {
          var p = e.charCoords(new i(e.firstLine(), 0), "div");
          p.left = n.lastHSPos, l = e.coordsChar(p, "div");
        }
      return n.lastHPos = l.ch, l;
    },
    moveByPage: function(e, t, r) {
      var n = t, a = r.repeat;
      return e.findPosV(n, r.forward ? a : -a, "page");
    },
    moveByParagraph: function(e, t, r) {
      var n = r.forward ? 1 : -1;
      return Ft(e, t, r.repeat, n);
    },
    moveBySentence: function(e, t, r) {
      var n = r.forward ? 1 : -1;
      return Yr(e, t, r.repeat, n);
    },
    moveByScroll: function(e, t, r, n) {
      var a = e.getScrollInfo(), o = null, l = r.repeat;
      l || (l = a.clientHeight / (2 * e.defaultTextHeight()));
      var h = e.charCoords(t, "local");
      if (r.repeat = l, o = de.moveByDisplayLines(e, t, r, n), !o)
        return null;
      var f = e.charCoords(o, "local");
      return e.scrollTo(null, a.top + f.top - h.top), o;
    },
    moveByWords: function(e, t, r) {
      return qr(
        e,
        t,
        r.repeat,
        !!r.forward,
        !!r.wordEnd,
        !!r.bigWord
      );
    },
    moveTillCharacter: function(e, t, r) {
      var n = r.repeat, a = ot(
        e,
        n,
        r.forward,
        r.selectedCharacter
      ), o = r.forward ? -1 : 1;
      return Kt(o, r), a ? (a.ch += o, a) : null;
    },
    moveToCharacter: function(e, t, r) {
      var n = r.repeat;
      return Kt(0, r), ot(
        e,
        n,
        r.forward,
        r.selectedCharacter
      ) || t;
    },
    moveToSymbol: function(e, t, r) {
      var n = r.repeat;
      return Jr(
        e,
        n,
        r.forward,
        r.selectedCharacter
      ) || t;
    },
    moveToColumn: function(e, t, r, n) {
      var a = r.repeat;
      return n.lastHPos = a - 1, n.lastHSPos = e.charCoords(t, "div").left, Gr(e, a);
    },
    moveToEol: function(e, t, r, n) {
      return Dt(e, t, r, n, !1);
    },
    moveToFirstNonWhiteSpaceCharacter: function(e, t) {
      var r = t;
      return new i(
        r.line,
        se(e.getLine(r.line))
      );
    },
    moveToMatchedSymbol: function(e, t) {
      for (var r = t, n = r.line, a = r.ch, o = e.getLine(n), l; a < o.length; a++)
        if (l = o.charAt(a), l && br(l)) {
          var h = e.getTokenTypeAt(new i(n, a + 1));
          if (h !== "string" && h !== "comment")
            break;
        }
      if (a < o.length) {
        var f = a === "<" || a === ">" ? /[(){}[\]<>]/ : /[(){}[\]]/, p = e.findMatchingBracket(new i(n, a), { bracketRegex: f });
        return p.to;
      } else
        return r;
    },
    moveToStartOfLine: function(e, t) {
      return new i(t.line, 0);
    },
    moveToLineOrEdgeOfDocument: function(e, t, r) {
      var n = r.forward ? e.lastLine() : e.firstLine();
      return r.repeatIsExplicit && (n = r.repeat - e.getOption("firstLineNumber")), new i(
        n,
        se(e.getLine(n))
      );
    },
    moveToStartOfDisplayLine: function(e) {
      return e.execCommand("goLineLeft"), e.getCursor();
    },
    moveToEndOfDisplayLine: function(e) {
      e.execCommand("goLineRight");
      var t = e.getCursor();
      return t.sticky == "before" && t.ch--, t;
    },
    textObjectManipulation: function(e, t, r, n) {
      var a = {
        "(": ")",
        ")": "(",
        "{": "}",
        "}": "{",
        "[": "]",
        "]": "[",
        "<": ">",
        ">": "<"
      }, o = { "'": !0, '"': !0, "`": !0 }, l = r.selectedCharacter;
      l == "b" ? l = "(" : l == "B" && (l = "{");
      var h = !r.textObjectInner, f;
      if (a[l])
        f = Zr(e, t, l, h);
      else if (o[l])
        f = en(e, t, l, h);
      else if (l === "W")
        f = We(
          e,
          h,
          !h,
          !0
          /** bigWord */
        );
      else if (l === "w")
        f = We(
          e,
          h,
          !h,
          !1
          /** bigWord */
        );
      else if (l === "p")
        if (f = Ft(e, t, r.repeat, 0, h), r.linewise = !0, n.visualMode)
          n.visualLine || (n.visualLine = !0);
        else {
          var p = n.inputState.operatorArgs;
          p && (p.linewise = !0), f.end.line--;
        }
      else if (l === "t")
        f = Ur(e, t, h);
      else if (l === "s") {
        var v = e.getLine(t.line);
        t.ch > 0 && Me(v[t.ch]) && (t.ch -= 1);
        var C = _t(e, t, r.repeat, 1, h), k = _t(e, t, r.repeat, -1, h);
        ee(e.getLine(k.line)[k.ch]) && ee(e.getLine(C.line)[C.ch - 1]) && (k = { line: k.line, ch: k.ch + 1 }), f = { start: k, end: C };
      }
      return f ? e.state.vim.visualMode ? Vr(e, f.start, f.end) : [f.start, f.end] : null;
    },
    repeatLastCharacterSearch: function(e, t, r) {
      var n = M.lastCharacterSearch, a = r.repeat, o = r.forward === n.forward, l = (n.increment ? 1 : 0) * (o ? -1 : 1);
      e.moveH(-l, "char"), r.inclusive = !!o;
      var h = ot(e, a, o, n.selectedCharacter);
      return h ? (h.ch += l, h) : (e.moveH(l, "char"), t);
    }
  };
  function Er(e, t) {
    de[e] = t;
  }
  function Tt(e, t) {
    for (var r = [], n = 0; n < t; n++)
      r.push(e);
    return r;
  }
  var nt = {
    change: function(e, t, r) {
      var n, a, o = e.state.vim, l = r[0].anchor, h = r[0].head;
      if (o.visualMode)
        if (t.fullLine)
          h.ch = Number.MAX_VALUE, h.line--, e.setSelection(l, h), a = e.getSelection(), e.replaceSelection(""), n = l;
        else {
          a = e.getSelection();
          var k = Tt("", r.length);
          e.replaceSelections(k), n = te(r[0].head, r[0].anchor);
        }
      else {
        a = e.getRange(l, h);
        var f = o.lastEditInputState || {};
        if (f.motion == "moveByWords" && !ee(a)) {
          var p = /\s+$/.exec(a);
          p && f.motionArgs && f.motionArgs.forward && (h = j(h, 0, -p[0].length), a = a.slice(0, -p[0].length));
        }
        var v = new i(l.line - 1, Number.MAX_VALUE), C = e.firstLine() == e.lastLine();
        h.line > e.lastLine() && t.linewise && !C ? e.replaceRange("", v, h) : e.replaceRange("", l, h), t.linewise && (C || (e.setCursor(v), c.commands.newlineAndIndent(e)), l.ch = Number.MAX_VALUE), n = l;
      }
      M.registerController.pushText(
        t.registerName,
        "change",
        a,
        t.linewise,
        r.length > 1
      ), Ie.enterInsertMode(e, { head: n }, e.state.vim);
    },
    // delete is a javascript keyword.
    delete: function(e, t, r) {
      var n, a, o = e.state.vim;
      if (o.visualBlock) {
        a = e.getSelection();
        var f = Tt("", r.length);
        e.replaceSelections(f), n = te(r[0].head, r[0].anchor);
      } else {
        var l = r[0].anchor, h = r[0].head;
        t.linewise && h.line != e.firstLine() && l.line == e.lastLine() && l.line == h.line - 1 && (l.line == e.firstLine() ? l.ch = 0 : l = new i(l.line - 1, J(e, l.line - 1))), a = e.getRange(l, h), e.replaceRange("", l, h), n = l, t.linewise && (n = de.moveToFirstNonWhiteSpaceCharacter(e, l));
      }
      return M.registerController.pushText(
        t.registerName,
        "delete",
        a,
        t.linewise,
        o.visualBlock
      ), X(e, n);
    },
    indent: function(e, t, r) {
      var n = e.state.vim;
      if (e.indentMore)
        for (var a = n.visualMode ? t.repeat : 1, o = 0; o < a; o++)
          t.indentRight ? e.indentMore() : e.indentLess();
      else {
        var l = r[0].anchor.line, h = n.visualBlock ? r[r.length - 1].anchor.line : r[0].head.line, a = n.visualMode ? t.repeat : 1;
        t.linewise && h--;
        for (var f = l; f <= h; f++)
          for (var o = 0; o < a; o++)
            e.indentLine(f, t.indentRight);
      }
      return de.moveToFirstNonWhiteSpaceCharacter(e, r[0].anchor);
    },
    indentAuto: function(e, t, r) {
      return e.execCommand("indentAuto"), de.moveToFirstNonWhiteSpaceCharacter(e, r[0].anchor);
    },
    changeCase: function(e, t, r, n, a) {
      for (var o = e.getSelections(), l = [], h = t.toLower, f = 0; f < o.length; f++) {
        var p = o[f], v = "";
        if (h === !0)
          v = p.toLowerCase();
        else if (h === !1)
          v = p.toUpperCase();
        else
          for (var C = 0; C < p.length; C++) {
            var k = p.charAt(C);
            v += Re(k) ? k.toLowerCase() : k.toUpperCase();
          }
        l.push(v);
      }
      return e.replaceSelections(l), t.shouldMoveCursor ? a : !e.state.vim.visualMode && t.linewise && r[0].anchor.line + 1 == r[0].head.line ? de.moveToFirstNonWhiteSpaceCharacter(e, n) : t.linewise ? n : te(r[0].anchor, r[0].head);
    },
    yank: function(e, t, r, n) {
      var a = e.state.vim, o = e.getSelection(), l = a.visualMode ? te(a.sel.anchor, a.sel.head, r[0].head, r[0].anchor) : n;
      return M.registerController.pushText(
        t.registerName,
        "yank",
        o,
        t.linewise,
        a.visualBlock
      ), l;
    }
  };
  function Ir(e, t) {
    nt[e] = t;
  }
  var Ie = {
    jumpListWalk: function(e, t, r) {
      if (!r.visualMode) {
        var n = t.repeat, a = t.forward, o = M.jumpList, l = o.move(e, a ? n : -n), h = l ? l.find() : void 0;
        h = h || e.getCursor(), e.setCursor(h);
      }
    },
    scroll: function(e, t, r) {
      if (!r.visualMode) {
        var n = t.repeat || 1, a = e.defaultTextHeight(), o = e.getScrollInfo().top, l = a * n, h = t.forward ? o + l : o - l, f = D(e.getCursor()), p = e.charCoords(f, "local");
        if (t.forward)
          h > p.top ? (f.line += (h - p.top) / a, f.line = Math.ceil(f.line), e.setCursor(f), p = e.charCoords(f, "local"), e.scrollTo(null, p.top)) : e.scrollTo(null, h);
        else {
          var v = h + e.getScrollInfo().clientHeight;
          v < p.bottom ? (f.line -= (p.bottom - v) / a, f.line = Math.floor(f.line), e.setCursor(f), p = e.charCoords(f, "local"), e.scrollTo(
            null,
            p.bottom - e.getScrollInfo().clientHeight
          )) : e.scrollTo(null, h);
        }
      }
    },
    scrollToCursor: function(e, t) {
      var r = e.getCursor().line, n = e.charCoords(new i(r, 0), "local"), a = e.getScrollInfo().clientHeight, o = n.top;
      switch (t.position) {
        case "center":
          o = n.bottom - a / 2;
          break;
        case "bottom":
          var l = new i(r, e.getLine(r).length - 1), h = e.charCoords(l, "local"), f = h.bottom - o;
          o = o - a + f;
          break;
      }
      e.scrollTo(null, o);
    },
    replayMacro: function(e, t, r) {
      var n = t.selectedCharacter, a = t.repeat, o = M.macroModeState;
      for (n == "@" ? n = o.latestRegister : o.latestRegister = n; a--; )
        pn(e, r, o, n);
    },
    enterMacroRecordMode: function(e, t) {
      var r = M.macroModeState, n = t.selectedCharacter;
      M.registerController.isValidRegister(n) && r.enterMacroRecordMode(e, n);
    },
    toggleOverwrite: function(e) {
      e.state.overwrite ? (e.toggleOverwrite(!1), e.setOption("keyMap", "vim-insert"), c.signal(e, "vim-mode-change", { mode: "insert" })) : (e.toggleOverwrite(!0), e.setOption("keyMap", "vim-replace"), c.signal(e, "vim-mode-change", { mode: "replace" }));
    },
    enterInsertMode: function(e, t, r) {
      if (!e.getOption("readOnly")) {
        r.insertMode = !0, r.insertModeRepeat = t && t.repeat || 1;
        var n = t ? t.insertAt : null, a = r.sel, o = t.head || e.getCursor("head"), l = e.listSelections().length;
        if (n == "eol")
          o = new i(o.line, J(e, o.line));
        else if (n == "bol")
          o = new i(o.line, 0);
        else if (n == "charAfter") {
          var h = u(e, o, j(o, 0, 1));
          o = h.end;
        } else if (n == "firstNonBlank") {
          var h = u(e, o, de.moveToFirstNonWhiteSpaceCharacter(e, o));
          o = h.end;
        } else if (n == "startOfSelectedArea") {
          if (!r.visualMode)
            return;
          r.visualBlock ? (o = new i(
            Math.min(a.head.line, a.anchor.line),
            Math.min(a.head.ch, a.anchor.ch)
          ), l = Math.abs(a.head.line - a.anchor.line) + 1) : a.head.line < a.anchor.line ? o = a.head : o = new i(a.anchor.line, 0);
        } else if (n == "endOfSelectedArea") {
          if (!r.visualMode)
            return;
          r.visualBlock ? (o = new i(
            Math.min(a.head.line, a.anchor.line),
            Math.max(a.head.ch, a.anchor.ch) + 1
          ), l = Math.abs(a.head.line - a.anchor.line) + 1) : a.head.line >= a.anchor.line ? o = j(a.head, 0, 1) : o = new i(a.anchor.line, 0);
        } else if (n == "inplace") {
          if (r.visualMode)
            return;
        } else
          n == "lastEdit" && (o = Jt(e) || o);
        e.setOption("disableInput", !1), t && t.replace ? (e.toggleOverwrite(!0), e.setOption("keyMap", "vim-replace"), c.signal(e, "vim-mode-change", { mode: "replace" })) : (e.toggleOverwrite(!1), e.setOption("keyMap", "vim-insert"), c.signal(e, "vim-mode-change", { mode: "insert" })), M.macroModeState.isPlaying || (e.on("change", Xt), c.on(e.getInputField(), "keydown", er)), r.visualMode && oe(e), It(e, o, l);
      }
    },
    toggleVisualMode: function(e, t, r) {
      var n = t.repeat, a = e.getCursor(), o;
      if (r.visualMode)
        r.visualLine ^ t.linewise || r.visualBlock ^ t.blockwise ? (r.visualLine = !!t.linewise, r.visualBlock = !!t.blockwise, c.signal(e, "vim-mode-change", { mode: "visual", subMode: r.visualLine ? "linewise" : r.visualBlock ? "blockwise" : "" }), Le(e)) : oe(e);
      else {
        r.visualMode = !0, r.visualLine = !!t.linewise, r.visualBlock = !!t.blockwise, o = X(
          e,
          new i(a.line, a.ch + n - 1)
        );
        var l = u(e, a, o);
        r.sel = {
          anchor: l.start,
          head: l.end
        }, c.signal(e, "vim-mode-change", { mode: "visual", subMode: r.visualLine ? "linewise" : r.visualBlock ? "blockwise" : "" }), Le(e), ve(e, r, "<", te(a, o)), ve(e, r, ">", ye(a, o));
      }
    },
    reselectLastSelection: function(e, t, r) {
      var n = r.lastSelection;
      if (r.visualMode && Bt(e, r), n) {
        var a = n.anchorMark.find(), o = n.headMark.find();
        if (!a || !o)
          return;
        r.sel = {
          anchor: a,
          head: o
        }, r.visualMode = !0, r.visualLine = n.visualLine, r.visualBlock = n.visualBlock, Le(e), ve(e, r, "<", te(a, o)), ve(e, r, ">", ye(a, o)), c.signal(e, "vim-mode-change", {
          mode: "visual",
          subMode: r.visualLine ? "linewise" : r.visualBlock ? "blockwise" : ""
        });
      }
    },
    joinLines: function(e, t, r) {
      var n, a;
      if (r.visualMode) {
        if (n = e.getCursor("anchor"), a = e.getCursor("head"), H(a, n)) {
          var o = a;
          a = n, n = o;
        }
        a.ch = J(e, a.line) - 1;
      } else {
        var l = Math.max(t.repeat, 2);
        n = e.getCursor(), a = X(e, new i(
          n.line + l - 1,
          1 / 0
        ));
      }
      for (var h = 0, f = n.line; f < a.line; f++) {
        h = J(e, n.line);
        var p = "", v = 0;
        if (!t.keepSpaces) {
          var C = e.getLine(n.line + 1);
          v = C.search(/\S/), v == -1 ? v = C.length : p = " ";
        }
        e.replaceRange(
          p,
          new i(n.line, h),
          new i(n.line + 1, v)
        );
      }
      var k = X(e, new i(n.line, h));
      r.visualMode && oe(e, !1), e.setCursor(k);
    },
    newLineAndEnterInsertMode: function(e, t, r) {
      r.insertMode = !0;
      var n = D(e.getCursor());
      if (n.line === e.firstLine() && !t.after)
        e.replaceRange(`
`, new i(e.firstLine(), 0)), e.setCursor(e.firstLine(), 0);
      else {
        n.line = t.after ? n.line : n.line - 1, n.ch = J(e, n.line), e.setCursor(n);
        var a = c.commands.newlineAndIndentContinueComment || c.commands.newlineAndIndent;
        a(e);
      }
      this.enterInsertMode(e, { repeat: t.repeat }, r);
    },
    paste: function(e, t, r) {
      var n = M.registerController.getRegister(
        t.registerName
      );
      if (t.registerName === "+")
        navigator.clipboard.readText().then((o) => {
          this.continuePaste(e, t, r, o, n);
        });
      else {
        var a = n.toString();
        this.continuePaste(e, t, r, a, n);
      }
    },
    continuePaste: function(e, t, r, n, a) {
      var o = D(e.getCursor());
      if (n) {
        if (t.matchIndent) {
          var l = e.getOption("tabSize"), h = function(Q) {
            var fe = Q.split("	").length - 1, Ke = Q.split(" ").length - 1;
            return fe * l + Ke * 1;
          }, f = e.getLine(e.getCursor().line), p = h(f.match(/^\s*/)[0]), v = n.replace(/\n$/, ""), C = n !== v, k = h(n.match(/^\s*/)[0]), n = v.replace(/^\s*/gm, function(Q) {
            var fe = p + (h(Q) - k);
            if (fe < 0)
              return "";
            if (e.getOption("indentWithTabs")) {
              var Ke = Math.floor(fe / l);
              return Array(Ke + 1).join("	");
            } else
              return Array(fe + 1).join(" ");
          });
          n += C ? `
` : "";
        }
        if (t.repeat > 1)
          var n = Array(t.repeat + 1).join(n);
        var g = a.linewise, y = a.blockwise;
        if (y) {
          n = n.split(`
`), g && n.pop();
          for (var S = 0; S < n.length; S++)
            n[S] = n[S] == "" ? " " : n[S];
          o.ch += t.after ? 1 : 0, o.ch = Math.min(J(e, o.line), o.ch);
        } else
          g ? r.visualMode ? n = r.visualLine ? n.slice(0, -1) : `
` + n.slice(0, n.length - 1) + `
` : t.after ? (n = `
` + n.slice(0, n.length - 1), o.ch = J(e, o.line)) : o.ch = 0 : o.ch += t.after ? 1 : 0;
        var w, b;
        if (r.visualMode) {
          r.lastPastedText = n;
          var O, A = Hr(e, r), B = A[0], U = A[1], V = e.getSelection(), z = e.listSelections(), P = new Array(z.length).join("1").split("1");
          r.lastSelection && (O = r.lastSelection.headMark.find()), M.registerController.unnamedRegister.setText(V), y ? (e.replaceSelections(P), U = new i(B.line + n.length - 1, B.ch), e.setCursor(B), Et(e, U), e.replaceSelections(n), w = B) : r.visualBlock ? (e.replaceSelections(P), e.setCursor(B), e.replaceRange(n, B, B), w = B) : (e.replaceRange(n, B, U), w = e.posFromIndex(e.indexFromPos(B) + n.length - 1)), O && (r.lastSelection.headMark = e.setBookmark(O)), g && (w.ch = 0);
        } else if (y) {
          e.setCursor(o);
          for (var S = 0; S < n.length; S++) {
            var R = o.line + S;
            R > e.lastLine() && e.replaceRange(`
`, new i(R, 0));
            var q = J(e, R);
            q < o.ch && Fr(e, R, o.ch);
          }
          e.setCursor(o), Et(e, new i(o.line + n.length - 1, o.ch)), e.replaceSelections(n), w = o;
        } else
          e.replaceRange(n, o), g && t.after ? w = new i(
            o.line + 1,
            se(e.getLine(o.line + 1))
          ) : g && !t.after ? w = new i(
            o.line,
            se(e.getLine(o.line))
          ) : !g && t.after ? (b = e.indexFromPos(o), w = e.posFromIndex(b + n.length - 1)) : (b = e.indexFromPos(o), w = e.posFromIndex(b + n.length));
        r.visualMode && oe(e, !1), e.setCursor(w);
      }
    },
    undo: function(e, t) {
      e.operation(function() {
        Ot(e, c.commands.undo, t.repeat)(), e.setCursor(X(e, e.getCursor("start")));
      });
    },
    redo: function(e, t) {
      Ot(e, c.commands.redo, t.repeat)();
    },
    setRegister: function(e, t, r) {
      r.inputState.registerName = t.selectedCharacter;
    },
    insertRegister: function(e, t, r) {
      var n = t.selectedCharacter, a = M.registerController.getRegister(n), o = a && a.toString();
      o && e.replaceSelection(o);
    },
    setMark: function(e, t, r) {
      var n = t.selectedCharacter;
      ve(e, r, n, e.getCursor());
    },
    replace: function(e, t, r) {
      var n = t.selectedCharacter, a = e.getCursor(), o, l, h = e.listSelections();
      if (r.visualMode)
        a = e.getCursor("start"), l = e.getCursor("end");
      else {
        var f = e.getLine(a.line);
        o = a.ch + t.repeat, o > f.length && (o = f.length), l = new i(a.line, o);
      }
      var p = u(e, a, l);
      if (a = p.start, l = p.end, n == `
`)
        r.visualMode || e.replaceRange("", a, l), (c.commands.newlineAndIndentContinueComment || c.commands.newlineAndIndent)(e);
      else {
        var v = e.getRange(a, l);
        if (v = v.replace(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g, n), v = v.replace(/[^\n]/g, n), r.visualBlock) {
          var C = new Array(e.getOption("tabSize") + 1).join(" ");
          v = e.getSelection(), v = v.replace(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g, n), v = v.replace(/\t/g, C).replace(/[^\n]/g, n).split(`
`), e.replaceSelections(v);
        } else
          e.replaceRange(v, a, l);
        r.visualMode ? (a = H(h[0].anchor, h[0].head) ? h[0].anchor : h[0].head, e.setCursor(a), oe(e, !1)) : e.setCursor(j(l, 0, -1));
      }
    },
    incrementNumberToken: function(e, t) {
      for (var r = e.getCursor(), n = e.getLine(r.line), a = /(-?)(?:(0x)([\da-f]+)|(0b|0|)(\d+))/gi, o, l, h, f; (o = a.exec(n)) !== null && (l = o.index, h = l + o[0].length, !(r.ch < h)); )
        ;
      if (!(!t.backtrack && h <= r.ch)) {
        if (o) {
          var p = o[2] || o[4], v = o[3] || o[5], C = t.increase ? 1 : -1, k = { "0b": 2, 0: 8, "": 10, "0x": 16 }[p.toLowerCase()], g = parseInt(o[1] + v, k) + C * t.repeat;
          f = g.toString(k);
          var y = p ? new Array(v.length - f.length + 1 + o[1].length).join("0") : "";
          f.charAt(0) === "-" ? f = "-" + p + y + f.substr(1) : f = p + y + f;
          var S = new i(r.line, l), w = new i(r.line, h);
          e.replaceRange(f, S, w);
        } else
          return;
        e.setCursor(new i(r.line, l + f.length - 1));
      }
    },
    repeatLastEdit: function(e, t, r) {
      var n = r.lastEditInputState;
      if (n) {
        var a = t.repeat;
        a && t.repeatIsExplicit ? r.lastEditInputState.repeatOverride = a : a = r.lastEditInputState.repeatOverride || a, tr(
          e,
          r,
          a,
          !1
          /** repeatForInsert */
        );
      }
    },
    indent: function(e, t) {
      e.indentLine(e.getCursor().line, t.indentRight);
    },
    exitInsertMode: Pe
  };
  function Br(e, t) {
    Ie[e] = t;
  }
  function X(e, t, r) {
    var n = e.state.vim, a = n.insertMode || n.visualMode, o = Math.min(Math.max(e.firstLine(), t.line), e.lastLine()), l = e.getLine(o), h = l.length - 1 + Number(!!a), f = Math.min(Math.max(0, t.ch), h), p = l.charCodeAt(f);
    if (56320 <= p && p <= 57343) {
      var v = 1;
      r && r.line == o && r.ch > f && (v = -1), f += v, f > h && (f -= 2);
    }
    return new i(o, f);
  }
  function Ve(e) {
    var t = {};
    for (var r in e)
      e.hasOwnProperty(r) && (t[r] = e[r]);
    return t;
  }
  function j(e, t, r) {
    return typeof t == "object" && (r = t.ch, t = t.line), new i(e.line + t, e.ch + r);
  }
  function Pr(e, t, r, n) {
    for (var a, o = [], l = [], h = 0; h < t.length; h++) {
      var f = t[h];
      r == "insert" && f.context != "insert" || f.context && f.context != r || n.operator && f.type == "action" || !(a = Kr(e, f.keys)) || (a == "partial" && o.push(f), a == "full" && l.push(f));
    }
    return {
      partial: o.length && o,
      full: l.length && l
    };
  }
  function Kr(e, t) {
    if (t.slice(-11) == "<character>") {
      var r = t.length - 11, n = e.slice(0, r), a = t.slice(0, r);
      return n == a && e.length > r ? "full" : a.indexOf(n) == 0 ? "partial" : !1;
    } else
      return e == t ? "full" : t.indexOf(e) == 0 ? "partial" : !1;
  }
  function Nr(e) {
    var t = /^.*(<[^>]+>)$/.exec(e), r = t ? t[1] : e.slice(-1);
    if (r.length > 1)
      switch (r) {
        case "<CR>":
          r = `
`;
          break;
        case "<Space>":
          r = " ";
          break;
        default:
          r = "";
          break;
      }
    return r;
  }
  function Ot(e, t, r) {
    return function() {
      for (var n = 0; n < r; n++)
        t(e);
    };
  }
  function D(e) {
    return new i(e.line, e.ch);
  }
  function re(e, t) {
    return e.ch == t.ch && e.line == t.line;
  }
  function H(e, t) {
    return e.line < t.line || e.line == t.line && e.ch < t.ch;
  }
  function te(e, t) {
    return arguments.length > 2 && (t = te.apply(void 0, Array.prototype.slice.call(arguments, 1))), H(e, t) ? e : t;
  }
  function ye(e, t) {
    return arguments.length > 2 && (t = ye.apply(void 0, Array.prototype.slice.call(arguments, 1))), H(e, t) ? t : e;
  }
  function Rt(e, t, r) {
    var n = H(e, t), a = H(t, r);
    return n && a;
  }
  function J(e, t) {
    return e.getLine(t).length;
  }
  function it(e) {
    return e.trim ? e.trim() : e.replace(/^\s+|\s+$/g, "");
  }
  function Dr(e) {
    return e.replace(/([.?*+$\[\]\/\\(){}|\-])/g, "\\$1");
  }
  function Fr(e, t, r) {
    var n = J(e, t), a = new Array(r - n + 1).join(" ");
    e.setCursor(new i(t, n)), e.replaceRange(a, e.getCursor());
  }
  function Et(e, t) {
    var r = [], n = e.listSelections(), a = D(e.clipPos(t)), o = !re(t, a), l = e.getCursor("head"), h = _r(n, l), f = re(n[h].head, n[h].anchor), p = n.length - 1, v = p - h > h ? p : 0, C = n[v].anchor, k = Math.min(C.line, a.line), g = Math.max(C.line, a.line), y = C.ch, S = a.ch, w = n[v].head.ch - y, b = S - y;
    w > 0 && b <= 0 ? (y++, o || S--) : w < 0 && b >= 0 ? (y--, f || S++) : w < 0 && b == -1 && (y--, S++);
    for (var O = k; O <= g; O++) {
      var A = { anchor: new i(O, y), head: new i(O, S) };
      r.push(A);
    }
    return e.setSelections(r), t.ch = S, C.ch = y, C;
  }
  function It(e, t, r) {
    for (var n = [], a = 0; a < r; a++) {
      var o = j(t, a, 0);
      n.push({ anchor: o, head: o });
    }
    e.setSelections(n, 0);
  }
  function _r(e, t, r) {
    for (var n = 0; n < e.length; n++) {
      var a = r != "head" && re(e[n].anchor, t), o = r != "anchor" && re(e[n].head, t);
      if (a || o)
        return n;
    }
    return -1;
  }
  function Hr(e, t) {
    var r = t.lastSelection, n = function() {
      var o = e.listSelections(), l = o[0], h = o[o.length - 1], f = H(l.anchor, l.head) ? l.anchor : l.head, p = H(h.anchor, h.head) ? h.head : h.anchor;
      return [f, p];
    }, a = function() {
      var o = e.getCursor(), l = e.getCursor(), h = r.visualBlock;
      if (h) {
        var f = h.width, p = h.height;
        l = new i(o.line + p, o.ch + f);
        for (var v = [], C = o.line; C < l.line; C++) {
          var k = new i(C, o.ch), g = new i(C, l.ch), y = { anchor: k, head: g };
          v.push(y);
        }
        e.setSelections(v);
      } else {
        var S = r.anchorMark.find(), w = r.headMark.find(), b = w.line - S.line, O = w.ch - S.ch;
        l = { line: l.line + b, ch: b ? l.ch : O + l.ch }, r.visualLine && (o = new i(o.line, 0), l = new i(l.line, J(e, l.line))), e.setSelection(o, l);
      }
      return [o, l];
    };
    return t.visualMode ? n() : a();
  }
  function Bt(e, t) {
    var r = t.sel.anchor, n = t.sel.head;
    t.lastPastedText && (n = e.posFromIndex(e.indexFromPos(r) + t.lastPastedText.length), t.lastPastedText = null), t.lastSelection = {
      anchorMark: e.setBookmark(r),
      headMark: e.setBookmark(n),
      anchor: D(r),
      head: D(n),
      visualMode: t.visualMode,
      visualLine: t.visualLine,
      visualBlock: t.visualBlock
    };
  }
  function Vr(e, t, r) {
    var n = e.state.vim.sel, a = n.head, o = n.anchor, l;
    return H(r, t) && (l = r, r = t, t = l), H(a, o) ? (a = te(t, a), o = ye(o, r)) : (o = te(t, o), a = ye(a, r), a = j(a, 0, -1), a.ch == -1 && a.line != e.firstLine() && (a = new i(a.line - 1, J(e, a.line - 1)))), [o, a];
  }
  function Le(e, t, a) {
    var n = e.state.vim;
    t = t || n.sel;
    var a = a || n.visualLine ? "line" : n.visualBlock ? "block" : "char", o = at(e, t, a);
    e.setSelections(o.ranges, o.primary);
  }
  function at(e, t, r, n) {
    var a = D(t.head), o = D(t.anchor);
    if (r == "char") {
      var l = !n && !H(t.head, t.anchor) ? 1 : 0, h = H(t.head, t.anchor) ? 1 : 0;
      return a = j(t.head, 0, l), o = j(t.anchor, 0, h), {
        ranges: [{ anchor: o, head: a }],
        primary: 0
      };
    } else if (r == "line") {
      if (H(t.head, t.anchor))
        a.ch = 0, o.ch = J(e, o.line);
      else {
        o.ch = 0;
        var f = e.lastLine();
        a.line > f && (a.line = f), a.ch = J(e, a.line);
      }
      return {
        ranges: [{ anchor: o, head: a }],
        primary: 0
      };
    } else if (r == "block") {
      var p = Math.min(o.line, a.line), v = o.ch, C = Math.max(o.line, a.line), k = a.ch;
      v < k ? k += 1 : v += 1;
      for (var g = C - p + 1, y = a.line == p ? 0 : g - 1, S = [], w = 0; w < g; w++)
        S.push({
          anchor: new i(p + w, v),
          head: new i(p + w, k)
        });
      return {
        ranges: S,
        primary: y
      };
    }
  }
  function Wr(e) {
    var t = e.getCursor("head");
    return e.getSelection().length == 1 && (t = te(t, e.getCursor("anchor"))), t;
  }
  function oe(e, t) {
    var r = e.state.vim;
    t !== !1 && e.setCursor(X(e, r.sel.head)), Bt(e, r), r.visualMode = !1, r.visualLine = !1, r.visualBlock = !1, r.insertMode || c.signal(e, "vim-mode-change", { mode: "normal" });
  }
  function $r(e, t, r) {
    var n = e.getRange(t, r);
    if (/\n\s*$/.test(n)) {
      var a = n.split(`
`);
      a.pop();
      for (var o, o = a.pop(); a.length > 0 && o && ee(o); o = a.pop())
        r.line--, r.ch = 0;
      o ? (r.line--, r.ch = J(e, r.line)) : r.ch = 0;
    }
  }
  function jr(e, t, r) {
    t.ch = 0, r.ch = 0, r.line++;
  }
  function se(e) {
    if (!e)
      return 0;
    var t = e.search(/\S/);
    return t == -1 ? e.length : t;
  }
  function We(e, t, r, n, a) {
    var o = Wr(e), l = e.getLine(o.line), h = o.ch, f = a ? ke[0] : ge[0];
    if (r && /\s/.test(l.charAt(h)))
      f = function(g) {
        return /\s/.test(g);
      };
    else {
      for (; !f(l.charAt(h)); )
        if (h++, h >= l.length)
          return null;
      n ? f = ge[0] : (f = ke[0], f(l.charAt(h)) || (f = ke[1]));
    }
    for (var p = h, v = h; f(l.charAt(p)) && p < l.length; )
      p++;
    for (; f(l.charAt(v)) && v >= 0; )
      v--;
    if (v++, t) {
      for (var C = p; /\s/.test(l.charAt(p)) && p < l.length; )
        p++;
      if (C == p) {
        for (var k = v; /\s/.test(l.charAt(v - 1)) && v > 0; )
          v--;
        v || (v = k);
      }
    }
    return { start: new i(o.line, v), end: new i(o.line, p) };
  }
  function Ur(e, t, r) {
    var n = t;
    if (!c.findMatchingTag || !c.findEnclosingTag)
      return { start: n, end: n };
    var a = c.findMatchingTag(e, t) || c.findEnclosingTag(e, t);
    return !a || !a.open || !a.close ? { start: n, end: n } : r ? { start: a.open.from, end: a.close.to } : { start: a.open.to, end: a.close.from };
  }
  function Pt(e, t, r) {
    re(t, r) || M.jumpList.add(e, t, r);
  }
  function Kt(e, t) {
    M.lastCharacterSearch.increment = e, M.lastCharacterSearch.forward = t.forward, M.lastCharacterSearch.selectedCharacter = t.selectedCharacter;
  }
  var Qr = {
    "(": "bracket",
    ")": "bracket",
    "{": "bracket",
    "}": "bracket",
    "[": "section",
    "]": "section",
    "*": "comment",
    "/": "comment",
    m: "method",
    M: "method",
    "#": "preprocess"
  }, Nt = {
    bracket: {
      isComplete: function(e) {
        if (e.nextCh === e.symb) {
          if (e.depth++, e.depth >= 1)
            return !0;
        } else
          e.nextCh === e.reverseSymb && e.depth--;
        return !1;
      }
    },
    section: {
      init: function(e) {
        e.curMoveThrough = !0, e.symb = (e.forward ? "]" : "[") === e.symb ? "{" : "}";
      },
      isComplete: function(e) {
        return e.index === 0 && e.nextCh === e.symb;
      }
    },
    comment: {
      isComplete: function(e) {
        var t = e.lastCh === "*" && e.nextCh === "/";
        return e.lastCh = e.nextCh, t;
      }
    },
    // TODO: The original Vim implementation only operates on level 1 and 2.
    // The current implementation doesn't check for code block level and
    // therefore it operates on any levels.
    method: {
      init: function(e) {
        e.symb = e.symb === "m" ? "{" : "}", e.reverseSymb = e.symb === "{" ? "}" : "{";
      },
      isComplete: function(e) {
        return e.nextCh === e.symb;
      }
    },
    preprocess: {
      init: function(e) {
        e.index = 0;
      },
      isComplete: function(e) {
        if (e.nextCh === "#") {
          var t = e.lineText.match(/^#(\w+)/)[1];
          if (t === "endif") {
            if (e.forward && e.depth === 0)
              return !0;
            e.depth++;
          } else if (t === "if") {
            if (!e.forward && e.depth === 0)
              return !0;
            e.depth--;
          }
          if (t === "else" && e.depth === 0)
            return !0;
        }
        return !1;
      }
    }
  };
  function Jr(e, t, r, n) {
    var a = D(e.getCursor()), o = r ? 1 : -1, l = r ? e.lineCount() : -1, h = a.ch, f = a.line, p = e.getLine(f), v = {
      lineText: p,
      nextCh: p.charAt(h),
      lastCh: null,
      index: h,
      symb: n,
      reverseSymb: (r ? { ")": "(", "}": "{" } : { "(": ")", "{": "}" })[n],
      forward: r,
      depth: 0,
      curMoveThrough: !1
    }, C = Qr[n];
    if (!C)
      return a;
    var k = Nt[C].init, g = Nt[C].isComplete;
    for (k && k(v); f !== l && t; ) {
      if (v.index += o, v.nextCh = v.lineText.charAt(v.index), !v.nextCh) {
        if (f += o, v.lineText = e.getLine(f) || "", o > 0)
          v.index = 0;
        else {
          var y = v.lineText.length;
          v.index = y > 0 ? y - 1 : 0;
        }
        v.nextCh = v.lineText.charAt(v.index);
      }
      g(v) && (a.line = f, a.ch = v.index, t--);
    }
    return v.nextCh || v.curMoveThrough ? new i(f, v.index) : a;
  }
  function zr(e, t, r, n, a) {
    var o = t.line, l = t.ch, h = e.getLine(o), f = r ? 1 : -1, p = n ? ge : ke;
    if (a && h == "") {
      if (o += f, h = e.getLine(o), !Ye(e, o))
        return null;
      l = r ? 0 : h.length;
    }
    for (; ; ) {
      if (a && h == "")
        return { from: 0, to: 0, line: o };
      for (var v = f > 0 ? h.length : -1, C = v, k = v; l != v; ) {
        for (var g = !1, y = 0; y < p.length && !g; ++y)
          if (p[y](h.charAt(l))) {
            for (C = l; l != v && p[y](h.charAt(l)); )
              l += f;
            if (k = l, g = C != k, C == t.ch && o == t.line && k == C + f)
              continue;
            return {
              from: Math.min(C, k + 1),
              to: Math.max(C, k),
              line: o
            };
          }
        g || (l += f);
      }
      if (o += f, !Ye(e, o))
        return null;
      h = e.getLine(o), l = f > 0 ? 0 : h.length;
    }
  }
  function qr(e, t, r, n, a, o) {
    var l = D(t), h = [];
    (n && !a || !n && a) && r++;
    for (var f = !(n && a), p = 0; p < r; p++) {
      var v = zr(e, t, n, o, f);
      if (!v) {
        var C = J(e, e.lastLine());
        h.push(n ? { line: e.lastLine(), from: C, to: C } : { line: 0, from: 0, to: 0 });
        break;
      }
      h.push(v), t = new i(v.line, n ? v.to - 1 : v.from);
    }
    var k = h.length != r, g = h[0], y = h.pop();
    return n && !a ? (!k && (g.from != l.ch || g.line != l.line) && (y = h.pop()), new i(y.line, y.from)) : n && a ? new i(y.line, y.to - 1) : !n && a ? (!k && (g.to != l.ch || g.line != l.line) && (y = h.pop()), new i(y.line, y.to)) : new i(y.line, y.from);
  }
  function Dt(e, t, r, n, a) {
    var o = t, l = new i(o.line + r.repeat - 1, 1 / 0), h = e.clipPos(l);
    return h.ch--, a || (n.lastHPos = 1 / 0, n.lastHSPos = e.charCoords(h, "div").left), l;
  }
  function ot(e, t, r, n) {
    for (var a = e.getCursor(), o = a.ch, l, h = 0; h < t; h++) {
      var f = e.getLine(a.line);
      if (l = Xr(o, f, n, r, !0), l == -1)
        return null;
      o = l;
    }
    return new i(e.getCursor().line, l);
  }
  function Gr(e, t) {
    var r = e.getCursor().line;
    return X(e, new i(r, t - 1));
  }
  function ve(e, t, r, n) {
    et(r, Lr) && (t.marks[r] && t.marks[r].clear(), t.marks[r] = e.setBookmark(n));
  }
  function Xr(e, t, r, n, a) {
    var o;
    return n ? (o = t.indexOf(r, e + 1), o != -1 && !a && (o -= 1)) : (o = t.lastIndexOf(r, e - 1), o != -1 && !a && (o += 1)), o;
  }
  function Ft(e, t, r, n, a) {
    var o = t.line, l = e.firstLine(), h = e.lastLine(), f, p, v = o;
    function C(w) {
      return !e.getLine(w);
    }
    function k(w, b, O) {
      return O ? C(w) != C(w + b) : !C(w) && C(w + b);
    }
    if (n) {
      for (; l <= v && v <= h && r > 0; )
        k(v, n) && r--, v += n;
      return new i(v, 0);
    }
    var g = e.state.vim;
    if (g.visualLine && k(o, 1, !0)) {
      var y = g.sel.anchor;
      k(y.line, -1, !0) && (!a || y.line != o) && (o += 1);
    }
    var S = C(o);
    for (v = o; v <= h && r; v++)
      k(v, 1, !0) && (!a || C(v) != S) && r--;
    for (p = new i(v, 0), v > h && !S ? S = !0 : a = !1, v = o; v > l && !((!a || C(v) == S || v == o) && k(v, -1, !0)); v--)
      ;
    return f = new i(v, 0), { start: f, end: p };
  }
  function _t(e, t, r, n, a) {
    function o(p) {
      p.pos + p.dir < 0 || p.pos + p.dir >= p.line.length ? p.line = null : p.pos += p.dir;
    }
    function l(p, v, C, k) {
      var g = p.getLine(v), y = {
        line: g,
        ln: v,
        pos: C,
        dir: k
      };
      if (y.line === "")
        return { ln: y.ln, pos: y.pos };
      var S = y.pos;
      for (o(y); y.line !== null; ) {
        if (S = y.pos, Me(y.line[y.pos]))
          if (a) {
            for (o(y); y.line !== null && ee(y.line[y.pos]); )
              S = y.pos, o(y);
            return { ln: y.ln, pos: S + 1 };
          } else
            return { ln: y.ln, pos: y.pos + 1 };
        o(y);
      }
      return { ln: y.ln, pos: S + 1 };
    }
    function h(p, v, C, k) {
      var g = p.getLine(v), y = {
        line: g,
        ln: v,
        pos: C,
        dir: k
      };
      if (y.line === "")
        return { ln: y.ln, pos: y.pos };
      var S = y.pos;
      for (o(y); y.line !== null; ) {
        if (!ee(y.line[y.pos]) && !Me(y.line[y.pos]))
          S = y.pos;
        else if (Me(y.line[y.pos]))
          return a ? ee(y.line[y.pos + 1]) ? { ln: y.ln, pos: y.pos + 1 } : { ln: y.ln, pos: S } : { ln: y.ln, pos: S };
        o(y);
      }
      return y.line = g, a && ee(y.line[y.pos]) ? { ln: y.ln, pos: y.pos } : { ln: y.ln, pos: S };
    }
    for (var f = {
      ln: t.line,
      pos: t.ch
    }; r > 0; )
      n < 0 ? f = h(e, f.ln, f.pos, n) : f = l(e, f.ln, f.pos, n), r--;
    return new i(f.ln, f.pos);
  }
  function Yr(e, t, r, n) {
    function a(f, p) {
      if (p.pos + p.dir < 0 || p.pos + p.dir >= p.line.length) {
        if (p.ln += p.dir, !Ye(f, p.ln)) {
          p.line = null, p.ln = null, p.pos = null;
          return;
        }
        p.line = f.getLine(p.ln), p.pos = p.dir > 0 ? 0 : p.line.length - 1;
      } else
        p.pos += p.dir;
    }
    function o(f, p, v, C) {
      var w = f.getLine(p), k = w === "", g = {
        line: w,
        ln: p,
        pos: v,
        dir: C
      }, y = {
        ln: g.ln,
        pos: g.pos
      }, S = g.line === "";
      for (a(f, g); g.line !== null; ) {
        if (y.ln = g.ln, y.pos = g.pos, g.line === "" && !S)
          return { ln: g.ln, pos: g.pos };
        if (k && g.line !== "" && !ee(g.line[g.pos]))
          return { ln: g.ln, pos: g.pos };
        Me(g.line[g.pos]) && !k && (g.pos === g.line.length - 1 || ee(g.line[g.pos + 1])) && (k = !0), a(f, g);
      }
      var w = f.getLine(y.ln);
      y.pos = 0;
      for (var b = w.length - 1; b >= 0; --b)
        if (!ee(w[b])) {
          y.pos = b;
          break;
        }
      return y;
    }
    function l(f, p, v, C) {
      var S = f.getLine(p), k = {
        line: S,
        ln: p,
        pos: v,
        dir: C
      }, g = {
        ln: k.ln,
        pos: null
      }, y = k.line === "";
      for (a(f, k); k.line !== null; ) {
        if (k.line === "" && !y)
          return g.pos !== null ? g : { ln: k.ln, pos: k.pos };
        if (Me(k.line[k.pos]) && g.pos !== null && !(k.ln === g.ln && k.pos + 1 === g.pos))
          return g;
        k.line !== "" && !ee(k.line[k.pos]) && (y = !1, g = { ln: k.ln, pos: k.pos }), a(f, k);
      }
      var S = f.getLine(g.ln);
      g.pos = 0;
      for (var w = 0; w < S.length; ++w)
        if (!ee(S[w])) {
          g.pos = w;
          break;
        }
      return g;
    }
    for (var h = {
      ln: t.line,
      pos: t.ch
    }; r > 0; )
      n < 0 ? h = l(e, h.ln, h.pos, n) : h = o(e, h.ln, h.pos, n), r--;
    return new i(h.ln, h.pos);
  }
  function Zr(e, t, r, n) {
    var a = t, o, l, h = {
      "(": /[()]/,
      ")": /[()]/,
      "[": /[[\]]/,
      "]": /[[\]]/,
      "{": /[{}]/,
      "}": /[{}]/,
      "<": /[<>]/,
      ">": /[<>]/
    }[r], f = {
      "(": "(",
      ")": "(",
      "[": "[",
      "]": "[",
      "{": "{",
      "}": "{",
      "<": "<",
      ">": "<"
    }[r], p = e.getLine(a.line).charAt(a.ch), v = p === f ? 1 : 0;
    if (o = e.scanForBracket(new i(a.line, a.ch + v), -1, void 0, { bracketRegex: h }), l = e.scanForBracket(new i(a.line, a.ch + v), 1, void 0, { bracketRegex: h }), !o || !l)
      return { start: a, end: a };
    if (o = o.pos, l = l.pos, o.line == l.line && o.ch > l.ch || o.line > l.line) {
      var C = o;
      o = l, l = C;
    }
    return n ? l.ch += 1 : o.ch += 1, { start: o, end: l };
  }
  function en(e, t, r, n) {
    var a = D(t), o = e.getLine(a.line), l = o.split(""), h, f, p, v, C = l.indexOf(r);
    if (a.ch < C ? a.ch = C : C < a.ch && l[a.ch] == r && (f = a.ch, --a.ch), l[a.ch] == r && !f)
      h = a.ch + 1;
    else
      for (p = a.ch; p > -1 && !h; p--)
        l[p] == r && (h = p + 1);
    if (h && !f)
      for (p = h, v = l.length; p < v && !f; p++)
        l[p] == r && (f = p);
    return !h || !f ? { start: a, end: a } : (n && (--h, ++f), {
      start: new i(a.line, h),
      end: new i(a.line, f)
    });
  }
  Fe("pcre", !0, "boolean");
  function Ht() {
  }
  Ht.prototype = {
    getQuery: function() {
      return M.query;
    },
    setQuery: function(e) {
      M.query = e;
    },
    getOverlay: function() {
      return this.searchOverlay;
    },
    setOverlay: function(e) {
      this.searchOverlay = e;
    },
    isReversed: function() {
      return M.isReversed;
    },
    setReversed: function(e) {
      M.isReversed = e;
    },
    getScrollbarAnnotate: function() {
      return this.annotate;
    },
    setScrollbarAnnotate: function(e) {
      this.annotate = e;
    }
  };
  function le(e) {
    var t = e.state.vim;
    return t.searchState_ || (t.searchState_ = new Ht());
  }
  function tn(e) {
    return Vt(e, "/");
  }
  function rn(e) {
    return Wt(e, "/");
  }
  function Vt(e, t) {
    var r = Wt(e, t) || [];
    if (!r.length)
      return [];
    var n = [];
    if (r[0] === 0) {
      for (var a = 0; a < r.length; a++)
        typeof r[a] == "number" && n.push(e.substring(r[a] + 1, r[a + 1]));
      return n;
    }
  }
  function Wt(e, t) {
    t || (t = "/");
    for (var r = !1, n = [], a = 0; a < e.length; a++) {
      var o = e.charAt(a);
      !r && o == t && n.push(a), r = !r && o == "\\";
    }
    return n;
  }
  function nn(e) {
    for (var t = "|(){", r = "}", n = !1, a = [], o = -1; o < e.length; o++) {
      var l = e.charAt(o) || "", h = e.charAt(o + 1) || "", f = h && t.indexOf(h) != -1;
      n ? ((l !== "\\" || !f) && a.push(l), n = !1) : l === "\\" ? (n = !0, h && r.indexOf(h) != -1 && (f = !0), (!f || h === "\\") && a.push(l)) : (a.push(l), f && h !== "\\" && a.push("\\"));
    }
    return a.join("");
  }
  var $t = { "\\n": `
`, "\\r": "\r", "\\t": "	" };
  function an(e) {
    for (var t = !1, r = [], n = -1; n < e.length; n++) {
      var a = e.charAt(n) || "", o = e.charAt(n + 1) || "";
      $t[a + o] ? (r.push($t[a + o]), n++) : t ? (r.push(a), t = !1) : a === "\\" ? (t = !0, Ar(o) || o === "$" ? r.push("$") : o !== "/" && o !== "\\" && r.push("\\")) : (a === "$" && r.push("$"), r.push(a), o === "/" && r.push("\\"));
    }
    return r.join("");
  }
  var jt = { "\\/": "/", "\\\\": "\\", "\\n": `
`, "\\r": "\r", "\\t": "	", "\\&": "&" };
  function on(e) {
    for (var t = new c.StringStream(e), r = []; !t.eol(); ) {
      for (; t.peek() && t.peek() != "\\"; )
        r.push(t.next());
      var n = !1;
      for (var a in jt)
        if (t.match(a, !0)) {
          n = !0, r.push(jt[a]);
          break;
        }
      n || r.push(t.next());
    }
    return r.join("");
  }
  function sn(e, t, r) {
    var n = M.registerController.getRegister("/");
    if (n.setText(e), e instanceof RegExp)
      return e;
    var a = rn(e), o, l;
    if (!a.length)
      o = e;
    else {
      o = e.substring(0, a[0]);
      var h = e.substring(a[0]);
      l = h.indexOf("i") != -1;
    }
    if (!o)
      return null;
    we("pcre") || (o = nn(o)), r && (t = /^[^A-Z]*$/.test(o));
    var f = new RegExp(
      o,
      t || l ? "im" : "m"
    );
    return f;
  }
  function me(e) {
    typeof e == "string" && (e = document.createElement(e));
    for (var t, r = 1; r < arguments.length; r++)
      if (t = arguments[r])
        if (typeof t != "object" && (t = document.createTextNode(t)), t.nodeType)
          e.appendChild(t);
        else
          for (var n in t)
            Object.prototype.hasOwnProperty.call(t, n) && (n[0] === "$" ? e.style[n.slice(1)] = t[n] : e.setAttribute(n, t[n]));
    return e;
  }
  function K(e, t) {
    var r = me("div", { $color: "red", $whiteSpace: "pre", class: "cm-vim-message" }, t);
    e.openNotification ? e.openNotification(r, { bottom: !0, duration: 5e3 }) : alert(r.innerText);
  }
  function ln(e, t) {
    return me(
      document.createDocumentFragment(),
      me(
        "span",
        { $fontFamily: "monospace", $whiteSpace: "pre" },
        e,
        me("input", {
          type: "text",
          autocorrect: "off",
          autocapitalize: "off",
          spellcheck: "false"
        })
      ),
      t && me("span", { $color: "#888" }, t)
    );
  }
  function $e(e, t) {
    var r = ln(t.prefix, t.desc);
    if (e.openDialog)
      e.openDialog(r, t.onClose, {
        onKeyDown: t.onKeyDown,
        onKeyUp: t.onKeyUp,
        bottom: !0,
        selectValueOnOpen: !1,
        value: t.value
      });
    else {
      var n = "";
      typeof t.prefix != "string" && t.prefix && (n += t.prefix.textContent), t.desc && (n += " " + t.desc), t.onClose(prompt(n, ""));
    }
  }
  function un(e, t) {
    if (e instanceof RegExp && t instanceof RegExp) {
      for (var r = ["global", "multiline", "ignoreCase", "source"], n = 0; n < r.length; n++) {
        var a = r[n];
        if (e[a] !== t[a])
          return !1;
      }
      return !0;
    }
    return !1;
  }
  function Be(e, t, r, n) {
    if (t) {
      var a = le(e), o = sn(t, !!r, !!n);
      if (o)
        return Ut(e, o), un(o, a.getQuery()) || a.setQuery(o), o;
    }
  }
  function fn(e) {
    if (e.source.charAt(0) == "^")
      var t = !0;
    return {
      token: function(r) {
        if (t && !r.sol()) {
          r.skipToEnd();
          return;
        }
        var n = r.match(e, !1);
        if (n)
          return n[0].length == 0 ? (r.next(), "searching") : !r.sol() && (r.backUp(1), !e.exec(r.next() + n[0])) ? (r.next(), null) : (r.match(e), "searching");
        for (; !r.eol() && (r.next(), !r.match(e, !1)); )
          ;
      },
      query: e
    };
  }
  var je = 0;
  function Ut(e, t) {
    clearTimeout(je), je = setTimeout(function() {
      if (e.state.vim) {
        var r = le(e), n = r.getOverlay();
        (!n || t != n.query) && (n && e.removeOverlay(n), n = fn(t), e.addOverlay(n), e.showMatchesOnScrollbar && (r.getScrollbarAnnotate() && r.getScrollbarAnnotate().clear(), r.setScrollbarAnnotate(e.showMatchesOnScrollbar(t))), r.setOverlay(n));
      }
    }, 50);
  }
  function Qt(e, t, r, n) {
    return n === void 0 && (n = 1), e.operation(function() {
      for (var a = e.getCursor(), o = e.getSearchCursor(r, a), l = 0; l < n; l++) {
        var h = o.find(t);
        if (l == 0 && h && re(o.from(), a)) {
          var f = t ? o.from() : o.to();
          h = o.find(t), h && !h[0] && re(o.from(), f) && e.getLine(f.line).length == f.ch && (h = o.find(t));
        }
        if (!h && (o = e.getSearchCursor(
          r,
          t ? new i(e.lastLine()) : new i(e.firstLine(), 0)
        ), !o.find(t)))
          return;
      }
      return o.from();
    });
  }
  function cn(e, t, r, n, a) {
    return n === void 0 && (n = 1), e.operation(function() {
      var o = e.getCursor(), l = e.getSearchCursor(r, o), h = l.find(!t);
      !a.visualMode && h && re(l.from(), o) && l.find(!t);
      for (var f = 0; f < n; f++)
        if (h = l.find(t), !h && (l = e.getSearchCursor(
          r,
          t ? new i(e.lastLine()) : new i(e.firstLine(), 0)
        ), !l.find(t)))
          return;
      return [l.from(), l.to()];
    });
  }
  function st(e) {
    var t = le(e);
    e.removeOverlay(le(e).getOverlay()), t.setOverlay(null), t.getScrollbarAnnotate() && (t.getScrollbarAnnotate().clear(), t.setScrollbarAnnotate(null));
  }
  function hn(e, t, r) {
    return typeof e != "number" && (e = e.line), t instanceof Array ? et(e, t) : typeof r == "number" ? e >= t && e <= r : e == t;
  }
  function lt(e) {
    var t = e.getScrollInfo(), r = 6, n = 10, a = e.coordsChar({ left: 0, top: r + t.top }, "local"), o = t.clientHeight - n + t.top, l = e.coordsChar({ left: 0, top: o }, "local");
    return { top: a.line, bottom: l.line };
  }
  function Ue(e, t, r) {
    if (r == "'" || r == "`")
      return M.jumpList.find(e, -1) || new i(0, 0);
    if (r == ".")
      return Jt(e);
    var n = t.marks[r];
    return n && n.find();
  }
  function Jt(e) {
    for (var t = e.doc.history.done, r = t.length; r--; )
      if (t[r].changes)
        return D(t[r].changes[0].to);
  }
  var zt = function() {
    this.buildCommandMap_();
  };
  zt.prototype = {
    processCommand: function(e, t, r) {
      var n = this;
      e.operation(function() {
        e.curOp.isVimOp = !0, n._processCommand(e, t, r);
      });
    },
    _processCommand: function(e, t, r) {
      var n = e.state.vim, a = M.registerController.getRegister(":"), o = a.toString(), l = new c.StringStream(t);
      a.setText(t);
      var h = r || {};
      h.input = t;
      try {
        this.parseInput_(e, l, h);
      } catch (C) {
        throw K(e, C.toString()), C;
      }
      n.visualMode && oe(e);
      var f, p;
      if (!h.commandName)
        h.line !== void 0 && (p = "move");
      else if (f = this.matchCommand_(h.commandName), f) {
        if (p = f.name, f.excludeFromCommandHistory && a.setText(o), this.parseCommandArgs_(l, h, f), f.type == "exToKey") {
          for (var v = 0; v < f.toKeys.length; v++)
            he.handleKey(e, f.toKeys[v], "mapping");
          return;
        } else if (f.type == "exToEx") {
          this.processCommand(e, f.toInput);
          return;
        }
      }
      if (!p) {
        K(e, 'Not an editor command ":' + t + '"');
        return;
      }
      try {
        qt[p](e, h), (!f || !f.possiblyAsync) && h.callback && h.callback();
      } catch (C) {
        throw K(e, C.toString()), C;
      }
    },
    parseInput_: function(e, t, r) {
      var a, o;
      t.eatWhile(":"), t.eat("%") ? (r.line = e.firstLine(), r.lineEnd = e.lastLine()) : (r.line = this.parseLineSpec_(e, t), r.line !== void 0 && t.eat(",") && (r.lineEnd = this.parseLineSpec_(e, t))), r.line == null ? e.state.vim.visualMode ? (r.selectionLine = (a = Ue(e, e.state.vim, "<")) == null ? void 0 : a.line, r.selectionLineEnd = (o = Ue(e, e.state.vim, ">")) == null ? void 0 : o.line) : r.selectionLine = e.getCursor().line : (r.selectionLine = r.line, r.selectionLineEnd = r.lineEnd);
      var n = t.match(/^(\w+|!!|@@|[!#&*<=>@~])/);
      return n ? r.commandName = n[1] : r.commandName = t.match(/.*/)[0], r;
    },
    parseLineSpec_: function(e, t) {
      var r = t.match(/^(\d+)/);
      if (r)
        return parseInt(r[1], 10) - 1;
      switch (t.next()) {
        case ".":
          return this.parseLineSpecOffset_(t, e.getCursor().line);
        case "$":
          return this.parseLineSpecOffset_(t, e.lastLine());
        case "'":
          var n = t.next(), a = Ue(e, e.state.vim, n);
          if (!a)
            throw new Error("Mark not set");
          return this.parseLineSpecOffset_(t, a.line);
        case "-":
        case "+":
          return t.backUp(1), this.parseLineSpecOffset_(t, e.getCursor().line);
        default:
          t.backUp(1);
          return;
      }
    },
    parseLineSpecOffset_: function(e, t) {
      var r = e.match(/^([+-])?(\d+)/);
      if (r) {
        var n = parseInt(r[2], 10);
        r[1] == "-" ? t -= n : t += n;
      }
      return t;
    },
    parseCommandArgs_: function(e, t, r) {
      if (!e.eol()) {
        t.argString = e.match(/.*/)[0];
        var n = r.argDelimiter || /\s+/, a = it(t.argString).split(n);
        a.length && a[0] && (t.args = a);
      }
    },
    matchCommand_: function(e) {
      for (var t = e.length; t > 0; t--) {
        var r = e.substring(0, t);
        if (this.commandMap_[r]) {
          var n = this.commandMap_[r];
          if (n.name.indexOf(e) === 0)
            return n;
        }
      }
      return null;
    },
    buildCommandMap_: function() {
      this.commandMap_ = {};
      for (var e = 0; e < x.length; e++) {
        var t = x[e], r = t.shortName || t.name;
        this.commandMap_[r] = t;
      }
    },
    map: function(e, t, r) {
      if (e != ":" && e.charAt(0) == ":") {
        if (r)
          throw Error("Mode not supported for ex mappings");
        var n = e.substring(1);
        t != ":" && t.charAt(0) == ":" ? this.commandMap_[n] = {
          name: n,
          type: "exToEx",
          toInput: t.substring(1),
          user: !0
        } : this.commandMap_[n] = {
          name: n,
          type: "exToKey",
          toKeys: t,
          user: !0
        };
      } else if (t != ":" && t.charAt(0) == ":") {
        var a = {
          keys: e,
          type: "keyToEx",
          exArgs: { input: t.substring(1) }
        };
        r && (a.context = r), d.unshift(a);
      } else {
        var a = {
          keys: e,
          type: "keyToKey",
          toKeys: t
        };
        r && (a.context = r), d.unshift(a);
      }
    },
    unmap: function(e, t) {
      if (e != ":" && e.charAt(0) == ":") {
        if (t)
          throw Error("Mode not supported for ex mappings");
        var r = e.substring(1);
        if (this.commandMap_[r] && this.commandMap_[r].user)
          return delete this.commandMap_[r], !0;
      } else
        for (var n = e, a = 0; a < d.length; a++)
          if (n == d[a].keys && d[a].context === t)
            return d.splice(a, 1), !0;
    }
  };
  var qt = {
    colorscheme: function(e, t) {
      if (!t.args || t.args.length < 1) {
        K(e, e.getOption("theme"));
        return;
      }
      e.setOption("theme", t.args[0]);
    },
    map: function(e, t, r) {
      var n = t.args;
      if (!n || n.length < 2) {
        e && K(e, "Invalid mapping: " + t.input);
        return;
      }
      ue.map(n[0], n[1], r);
    },
    imap: function(e, t) {
      this.map(e, t, "insert");
    },
    nmap: function(e, t) {
      this.map(e, t, "normal");
    },
    vmap: function(e, t) {
      this.map(e, t, "visual");
    },
    unmap: function(e, t, r) {
      var n = t.args;
      (!n || n.length < 1 || !ue.unmap(n[0], r)) && e && K(e, "No such mapping: " + t.input);
    },
    move: function(e, t) {
      Se.processCommand(e, e.state.vim, {
        type: "motion",
        motion: "moveToLineOrEdgeOfDocument",
        motionArgs: {
          forward: !1,
          explicitRepeat: !0,
          linewise: !0
        },
        repeatOverride: t.line + 1
      });
    },
    set: function(e, t) {
      var r = t.args, n = t.setCfg || {};
      if (!r || r.length < 1) {
        e && K(e, "Invalid mapping: " + t.input);
        return;
      }
      var a = r[0].split("="), o = a[0], l = a[1], h = !1;
      if (o.charAt(o.length - 1) == "?") {
        if (l)
          throw Error("Trailing characters: " + t.argString);
        o = o.substring(0, o.length - 1), h = !0;
      }
      l === void 0 && o.substring(0, 2) == "no" && (o = o.substring(2), l = !1);
      var f = ce[o] && ce[o].type == "boolean";
      if (f && l == null && (l = !0), !f && l === void 0 || h) {
        var p = we(o, e, n);
        p instanceof Error ? K(e, p.message) : p === !0 || p === !1 ? K(e, " " + (p ? "" : "no") + o) : K(e, "  " + o + "=" + p);
      } else {
        var v = tt(o, l, e, n);
        v instanceof Error && K(e, v.message);
      }
    },
    setlocal: function(e, t) {
      t.setCfg = { scope: "local" }, this.set(e, t);
    },
    setglobal: function(e, t) {
      t.setCfg = { scope: "global" }, this.set(e, t);
    },
    registers: function(e, t) {
      var r = t.args, n = M.registerController.registers, a = `----------Registers----------

`;
      if (r) {
        var o;
        r = r.join("");
        for (var h = 0; h < r.length; h++)
          if (o = r.charAt(h), !!M.registerController.isValidRegister(o)) {
            var f = n[o] || new ae();
            a += '"' + o + "    " + f.toString() + `
`;
          }
      } else
        for (var o in n) {
          var l = n[o].toString();
          l.length && (a += '"' + o + "    " + l + `
`);
        }
      K(e, a);
    },
    sort: function(e, t) {
      var r, n, a, o, l;
      function h() {
        if (t.argString) {
          var P = new c.StringStream(t.argString);
          if (P.eat("!") && (r = !0), P.eol())
            return;
          if (!P.eatSpace())
            return "Invalid arguments";
          var R = P.match(/([dinuox]+)?\s*(\/.+\/)?\s*/);
          if (!R && !P.eol())
            return "Invalid arguments";
          if (R[1]) {
            n = R[1].indexOf("i") != -1, a = R[1].indexOf("u") != -1;
            var q = R[1].indexOf("d") != -1 || R[1].indexOf("n") != -1 && 1, Z = R[1].indexOf("x") != -1 && 1, Q = R[1].indexOf("o") != -1 && 1;
            if (q + Z + Q > 1)
              return "Invalid arguments";
            o = q && "decimal" || Z && "hex" || Q && "octal";
          }
          R[2] && (l = new RegExp(R[2].substr(1, R[2].length - 2), n ? "i" : ""));
        }
      }
      var f = h();
      if (f) {
        K(e, f + ": " + t.argString);
        return;
      }
      var p = t.line || e.firstLine(), v = t.lineEnd || t.line || e.lastLine();
      if (p == v)
        return;
      var C = new i(p, 0), k = new i(v, J(e, v)), g = e.getRange(C, k).split(`
`), y = l || (o == "decimal" ? /(-?)([\d]+)/ : o == "hex" ? /(-?)(?:0x)?([0-9a-f]+)/i : o == "octal" ? /([0-7]+)/ : null), S = o == "decimal" ? 10 : o == "hex" ? 16 : o == "octal" ? 8 : null, w = [], b = [];
      if (o || l)
        for (var O = 0; O < g.length; O++) {
          var A = l ? g[O].match(l) : null;
          A && A[0] != "" ? w.push(A) : !l && y.exec(g[O]) ? w.push(g[O]) : b.push(g[O]);
        }
      else
        b = g;
      function B(P, R) {
        if (r) {
          var q;
          q = P, P = R, R = q;
        }
        n && (P = P.toLowerCase(), R = R.toLowerCase());
        var Z = o && y.exec(P), Q = o && y.exec(R);
        return Z ? (Z = parseInt((Z[1] + Z[2]).toLowerCase(), S), Q = parseInt((Q[1] + Q[2]).toLowerCase(), S), Z - Q) : P < R ? -1 : 1;
      }
      function U(P, R) {
        if (r) {
          var q;
          q = P, P = R, R = q;
        }
        return n && (P[0] = P[0].toLowerCase(), R[0] = R[0].toLowerCase()), P[0] < R[0] ? -1 : 1;
      }
      if (w.sort(l ? U : B), l)
        for (var O = 0; O < w.length; O++)
          w[O] = w[O].input;
      else
        o || b.sort(B);
      if (g = r ? w.concat(b) : b.concat(w), a) {
        var V = g, z;
        g = [];
        for (var O = 0; O < V.length; O++)
          V[O] != z && g.push(V[O]), z = V[O];
      }
      e.replaceRange(g.join(`
`), C, k);
    },
    vglobal: function(e, t) {
      this.global(e, t);
    },
    global: function(e, t) {
      var r = t.argString;
      if (!r) {
        K(e, "Regular Expression missing from global");
        return;
      }
      var n = t.commandName[0] === "v";
      r[0] === "!" && t.commandName[0] === "g" && (n = !0, r = r.slice(1));
      var a = t.line !== void 0 ? t.line : e.firstLine(), o = t.lineEnd || t.line || e.lastLine(), l = tn(r), h = r, f;
      if (l.length && (h = l[0], f = l.slice(1, l.length).join("/")), h)
        try {
          Be(
            e,
            h,
            !0,
            !0
            /** smartCase */
          );
        } catch {
          K(e, "Invalid regex: " + h);
          return;
        }
      for (var p = le(e).getQuery(), v = [], C = a; C <= o; C++) {
        var k = e.getLine(C), g = p.test(k);
        g !== n && v.push(f ? e.getLineHandle(C) : k);
      }
      if (!f) {
        K(e, v.join(`
`));
        return;
      }
      var y = 0, S = function() {
        if (y < v.length) {
          var w = v[y++], b = e.getLineNumber(w);
          if (b == null) {
            S();
            return;
          }
          var O = b + 1 + f;
          ue.processCommand(e, O, {
            callback: S
          });
        } else
          e.releaseLineHandles && e.releaseLineHandles();
      };
      S();
    },
    substitute: function(e, t) {
      if (!e.getSearchCursor)
        throw new Error("Search feature not available. Requires searchcursor.js or any other getSearchCursor implementation.");
      var r = t.argString, n = r ? Vt(r, r[0]) : [], a, o = "", l, h, f, p = !1, v = !1;
      if (n.length)
        a = n[0], we("pcre") && a !== "" && (a = new RegExp(a).source), o = n[1], o !== void 0 && (we("pcre") ? o = on(o.replace(/([^\\])&/g, "$1$$&")) : o = an(o), M.lastSubstituteReplacePart = o), l = n[2] ? n[2].split(" ") : [];
      else if (r && r.length) {
        K(e, "Substitutions should be of the form :s/pattern/replace/");
        return;
      }
      if (l && (h = l[0], f = parseInt(l[1]), h && (h.indexOf("c") != -1 && (p = !0), h.indexOf("g") != -1 && (v = !0), we("pcre") ? a = a + "/" + h : a = a.replace(/\//g, "\\/") + "/" + h)), a)
        try {
          Be(
            e,
            a,
            !0,
            !0
            /** smartCase */
          );
        } catch {
          K(e, "Invalid regex: " + a);
          return;
        }
      if (o = o || M.lastSubstituteReplacePart, o === void 0) {
        K(e, "No previous substitute regular expression");
        return;
      }
      var C = le(e), k = C.getQuery(), g = t.line !== void 0 ? t.line : e.getCursor().line, y = t.lineEnd || g;
      g == e.firstLine() && y == e.lastLine() && (y = 1 / 0), f && (g = y, y = g + f - 1);
      var S = X(e, new i(g, 0)), w = e.getSearchCursor(k, S);
      dn(e, p, v, g, y, w, k, o, t.callback);
    },
    redo: c.commands.redo,
    undo: c.commands.undo,
    write: function(e) {
      c.commands.save ? c.commands.save(e) : e.save && e.save();
    },
    nohlsearch: function(e) {
      st(e);
    },
    yank: function(e) {
      var t = D(e.getCursor()), r = t.line, n = e.getLine(r);
      M.registerController.pushText(
        "0",
        "yank",
        n,
        !0,
        !0
      );
    },
    delete: function(e, t) {
      var r = t.selectionLine, n = isNaN(t.selectionLineEnd) ? r : t.selectionLineEnd;
      nt.delete(e, { linewise: !0 }, [
        {
          anchor: new i(r, 0),
          head: new i(n + 1, 0)
        }
      ]);
    },
    join: function(e, t) {
      var r = t.selectionLine, n = isNaN(t.selectionLineEnd) ? r : t.selectionLineEnd;
      e.setCursor(new i(r, 0)), Ie.joinLines(e, { repeat: n - r }, e.state.vim);
    },
    delmarks: function(e, t) {
      if (!t.argString || !it(t.argString)) {
        K(e, "Argument required");
        return;
      }
      for (var r = e.state.vim, n = new c.StringStream(it(t.argString)); !n.eol(); ) {
        n.eatSpace();
        var a = n.pos;
        if (!n.match(/[a-zA-Z]/, !1)) {
          K(e, "Invalid argument: " + t.argString.substring(a));
          return;
        }
        var o = n.next();
        if (n.match("-", !0)) {
          if (!n.match(/[a-zA-Z]/, !1)) {
            K(e, "Invalid argument: " + t.argString.substring(a));
            return;
          }
          var l = o, h = n.next();
          if (Ze(l) && Ze(h) || Re(l) && Re(h)) {
            var f = l.charCodeAt(0), p = h.charCodeAt(0);
            if (f >= p) {
              K(e, "Invalid argument: " + t.argString.substring(a));
              return;
            }
            for (var v = 0; v <= p - f; v++) {
              var C = String.fromCharCode(f + v);
              delete r.marks[C];
            }
          } else {
            K(e, "Invalid argument: " + l + "-");
            return;
          }
        } else
          delete r.marks[o];
      }
    }
  }, ue = new zt();
  function dn(e, t, r, n, a, o, l, h, f) {
    e.state.vim.exMode = !0;
    var p = !1, v, C, k;
    function g() {
      e.operation(function() {
        for (; !p; )
          y(), w();
        b();
      });
    }
    function y() {
      var A = e.getRange(o.from(), o.to()), B = A.replace(l, h), U = o.to().line;
      o.replace(B), C = o.to().line, a += C - U, k = C < U;
    }
    function S() {
      var A = v && D(o.to()), B = o.findNext();
      return B && !B[0] && A && re(o.from(), A) && (B = o.findNext()), B;
    }
    function w() {
      for (; S() && hn(o.from(), n, a); )
        if (!(!r && o.from().line == C && !k)) {
          e.scrollIntoView(o.from(), 30), e.setSelection(o.from(), o.to()), v = o.from(), p = !1;
          return;
        }
      p = !0;
    }
    function b(A) {
      if (A && A(), e.focus(), v) {
        e.setCursor(v);
        var B = e.state.vim;
        B.exMode = !1, B.lastHPos = B.lastHSPos = v.ch;
      }
      f && f();
    }
    function O(A, B, U) {
      c.e_stop(A);
      var V = c.keyName(A);
      switch (V) {
        case "Y":
          y(), w();
          break;
        case "N":
          w();
          break;
        case "A":
          var z = f;
          f = void 0, e.operation(g), f = z;
          break;
        case "L":
          y();
        case "Q":
        case "Esc":
        case "Ctrl-C":
        case "Ctrl-[":
          b(U);
          break;
      }
      return p && b(U), !0;
    }
    if (w(), p) {
      K(e, "No matches for " + l.source);
      return;
    }
    if (!t) {
      g(), f && f();
      return;
    }
    $e(e, {
      prefix: me("span", "replace with ", me("strong", h), " (y/n/a/q/l)"),
      onKeyDown: O
    });
  }
  c.keyMap.vim = {
    attach: W,
    detach: N,
    call: F
  };
  function Pe(e) {
    var t = e.state.vim, r = M.macroModeState, n = M.registerController.getRegister("."), a = r.isPlaying, o = r.lastInsertModeChanges;
    a || (e.off("change", Xt), c.off(e.getInputField(), "keydown", er)), !a && t.insertModeRepeat > 1 && (tr(
      e,
      t,
      t.insertModeRepeat - 1,
      !0
      /** repeatForInsert */
    ), t.lastEditInputState.repeatOverride = t.insertModeRepeat), delete t.insertModeRepeat, t.insertMode = !1, e.setCursor(e.getCursor().line, e.getCursor().ch - 1), e.setOption("keyMap", "vim"), e.setOption("disableInput", !0), e.toggleOverwrite(!1), n.setText(o.changes.join("")), c.signal(e, "vim-mode-change", { mode: "normal" }), r.isRecording && yn(r);
  }
  function Gt(e) {
    d.unshift(e);
  }
  function vn(e, t, r, n, a) {
    var o = { keys: e, type: t };
    o[t] = r, o[t + "Args"] = n;
    for (var l in a)
      o[l] = a[l];
    Gt(o);
  }
  Fe("insertModeEscKeysTimeout", 200, "number"), c.keyMap["vim-insert"] = {
    // TODO: override navigation keys so that Esc will cancel automatic
    // indentation from o, O, i_<CR>
    fallthrough: ["default"],
    attach: W,
    detach: N,
    call: F
  }, c.keyMap["vim-replace"] = {
    Backspace: "goCharLeft",
    fallthrough: ["vim-insert"],
    attach: W,
    detach: N
  };
  function pn(e, t, r, n) {
    var a = M.registerController.getRegister(n);
    if (n == ":") {
      a.keyBuffer[0] && ue.processCommand(e, a.keyBuffer[0]), r.isPlaying = !1;
      return;
    }
    var o = a.keyBuffer, l = 0;
    r.isPlaying = !0, r.replaySearchQueries = a.searchQueries.slice(0);
    for (var h = 0; h < o.length; h++)
      for (var f = o[h], p, v; f; )
        if (p = /<\w+-.+?>|<\w+>|./.exec(f), v = p[0], f = f.substring(p.index + v.length), he.handleKey(e, v, "macro"), t.insertMode) {
          var C = a.insertModeChanges[l++].changes;
          M.macroModeState.lastInsertModeChanges.changes = C, rr(e, C, 1), Pe(e);
        }
    r.isPlaying = !1;
  }
  function gn(e, t) {
    if (!e.isPlaying) {
      var r = e.latestRegister, n = M.registerController.getRegister(r);
      n && n.pushText(t);
    }
  }
  function yn(e) {
    if (!e.isPlaying) {
      var t = e.latestRegister, r = M.registerController.getRegister(t);
      r && r.pushInsertModeChanges && r.pushInsertModeChanges(e.lastInsertModeChanges);
    }
  }
  function mn(e, t) {
    if (!e.isPlaying) {
      var r = e.latestRegister, n = M.registerController.getRegister(r);
      n && n.pushSearchQuery && n.pushSearchQuery(t);
    }
  }
  function Xt(e, t) {
    var r = M.macroModeState, n = r.lastInsertModeChanges;
    if (!r.isPlaying)
      for (; t; ) {
        if (n.expectCursorActivityForChange = !0, n.ignoreCount > 1)
          n.ignoreCount--;
        else if (t.origin == "+input" || t.origin == "paste" || t.origin === void 0) {
          var a = e.listSelections().length;
          a > 1 && (n.ignoreCount = a);
          var o = t.text.join(`
`);
          n.maybeReset && (n.changes = [], n.maybeReset = !1), o && (e.state.overwrite && !/\n/.test(o) ? n.changes.push([o]) : n.changes.push(o));
        }
        t = t.next;
      }
  }
  function Yt(e) {
    var t = e.state.vim;
    if (t.insertMode) {
      var r = M.macroModeState;
      if (r.isPlaying)
        return;
      var n = r.lastInsertModeChanges;
      n.expectCursorActivityForChange ? n.expectCursorActivityForChange = !1 : n.maybeReset = !0;
    } else
      e.curOp.isVimOp || Zt(e, t);
  }
  function Zt(e, t) {
    var r = e.getCursor("anchor"), n = e.getCursor("head");
    if (t.visualMode && !e.somethingSelected() ? oe(e, !1) : !t.visualMode && !t.insertMode && e.somethingSelected() && (t.visualMode = !0, t.visualLine = !1, c.signal(e, "vim-mode-change", { mode: "visual" })), t.visualMode) {
      var a = H(n, r) ? 0 : -1, o = H(n, r) ? -1 : 0;
      n = j(n, 0, a), r = j(r, 0, o), t.sel = {
        anchor: r,
        head: n
      }, ve(e, t, "<", te(n, r)), ve(e, t, ">", ye(n, r));
    } else
      t.insertMode || (t.lastHPos = e.getCursor().ch);
  }
  function ut(e) {
    this.keyName = e;
  }
  function er(e) {
    var t = M.macroModeState, r = t.lastInsertModeChanges, n = c.keyName(e);
    if (!n)
      return;
    function a() {
      return r.maybeReset && (r.changes = [], r.maybeReset = !1), r.changes.push(new ut(n)), !0;
    }
    (n.indexOf("Delete") != -1 || n.indexOf("Backspace") != -1) && c.lookupKey(n, "vim-insert", a);
  }
  function tr(e, t, r, n) {
    var a = M.macroModeState;
    a.isPlaying = !0;
    var o = !!t.lastEditActionCommand, l = t.inputState;
    function h() {
      o ? Se.processAction(e, t, t.lastEditActionCommand) : Se.evalInput(e, t);
    }
    function f(v) {
      if (a.lastInsertModeChanges.changes.length > 0) {
        v = t.lastEditActionCommand ? v : 1;
        var C = a.lastInsertModeChanges;
        rr(e, C.changes, v);
      }
    }
    if (t.inputState = t.lastEditInputState, o && t.lastEditActionCommand.interlaceInsertRepeat)
      for (var p = 0; p < r; p++)
        h(), f(1);
    else
      n || h(), f(r);
    t.inputState = l, t.insertMode && !n && Pe(e), a.isPlaying = !1;
  }
  function rr(e, t, r) {
    function n(C) {
      return typeof C == "string" ? c.commands[C](e) : C(e), !0;
    }
    var a = e.getCursor("head"), o = M.macroModeState.lastInsertModeChanges.visualBlock;
    o && (It(e, a, o + 1), r = e.listSelections().length, e.setCursor(a));
    for (var l = 0; l < r; l++) {
      o && e.setCursor(j(a, l, 0));
      for (var h = 0; h < t.length; h++) {
        var f = t[h];
        if (f instanceof ut)
          c.lookupKey(f.keyName, "vim-insert", n);
        else if (typeof f == "string")
          e.replaceSelection(f);
        else {
          var p = e.getCursor(), v = j(p, 0, f[0].length);
          e.replaceRange(f[0], p, v), e.setCursor(v);
        }
      }
    }
    o && e.setCursor(j(a, 0, 1));
  }
  function ft(e) {
    var t = new e.constructor();
    return Object.keys(e).forEach(function(r) {
      var n = e[r];
      Array.isArray(n) ? n = n.slice() : n && typeof n == "object" && n.constructor != Object && (n = ft(n)), t[r] = n;
    }), e.sel && (t.sel = {
      head: e.sel.head && D(e.sel.head),
      anchor: e.sel.anchor && D(e.sel.anchor)
    }), t;
  }
  function Cn(e, t, r) {
    var n = !1, a = he.maybeInitVimState_(e), o = a.visualBlock || a.wasInVisualBlock, l = e.isInMultiSelectMode();
    if (a.wasInVisualBlock && !l ? a.wasInVisualBlock = !1 : l && a.visualBlock && (a.wasInVisualBlock = !0), t == "<Esc>" && !a.insertMode && !a.visualMode && l && a.status == "<Esc>")
      G(e);
    else if (o || !l || e.inVirtualSelectionMode)
      n = he.handleKey(e, t, r);
    else {
      var h = ft(a), f = a.inputState.changeQueueList || [];
      e.operation(function() {
        e.curOp.isVimOp = !0;
        var p = 0;
        e.forEachSelection(function() {
          e.state.vim.inputState.changeQueue = f[p];
          var v = e.getCursor("head"), C = e.getCursor("anchor"), k = H(v, C) ? 0 : -1, g = H(v, C) ? -1 : 0;
          v = j(v, 0, k), C = j(C, 0, g), e.state.vim.sel.head = v, e.state.vim.sel.anchor = C, n = he.handleKey(e, t, r), e.virtualSelection && (f[p] = e.state.vim.inputState.changeQueue, e.state.vim = ft(h)), p++;
        }), e.curOp.cursorActivity && !n && (e.curOp.cursorActivity = !1), e.state.vim = a, a.inputState.changeQueueList = f, a.inputState.changeQueue = null;
      }, !0);
    }
    return n && !a.visualMode && !a.insert && a.visualMode != e.somethingSelected() && Zt(e, a), n;
  }
  return bt(), he;
}
var pr = typeof navigator < "u" && /* @__PURE__ */ /Mac/.test(navigator.platform);
function Y(c, i) {
  var s = i.ch, u = i.line + 1;
  u < 1 && (u = 1, s = 0), u > c.lines && (u = c.lines, s = Number.MAX_VALUE);
  var d = c.line(u);
  return Math.min(d.from + Math.max(0, s), d.to);
}
function ie(c, i) {
  let s = c.lineAt(i);
  return { line: s.number - 1, ch: i - s.from };
}
class qe {
  constructor(i, s) {
    this.line = i, this.ch = s;
  }
}
function gr(c, i, s) {
  if (c.addEventListener)
    c.addEventListener(i, s, !1);
  else {
    var u = c._handlers || (c._handlers = {});
    u[i] = (u[i] || []).concat(s);
  }
}
function yr(c, i, s) {
  if (c.removeEventListener)
    c.removeEventListener(i, s, !1);
  else {
    var u = c._handlers, d = u && u[i];
    if (d) {
      var m = d.indexOf(s);
      m > -1 && (u[i] = d.slice(0, m).concat(d.slice(m + 1)));
    }
  }
}
function mr(c, i, ...s) {
  var u, d = (u = c._handlers) === null || u === void 0 ? void 0 : u[i];
  if (d)
    for (var m = 0; m < d.length; ++m)
      d[m](...s);
}
function ar(c, ...i) {
  if (c)
    for (var s = 0; s < c.length; ++s)
      c[s](...i);
}
var Yn = {
  Return: "CR",
  Backspace: "BS",
  Delete: "Del",
  Escape: "Esc",
  Insert: "Ins",
  ArrowLeft: "Left",
  ArrowRight: "Right",
  ArrowUp: "Up",
  ArrowDown: "Down",
  Enter: "CR",
  " ": "Space"
}, Cr = {
  Shift: 1,
  Alt: 1,
  Command: 1,
  Control: 1,
  CapsLock: 1,
  AltGraph: 1,
  Dead: 1
};
let gt;
try {
  gt = /* @__PURE__ */ new RegExp("[\\w\\p{Alphabetic}\\p{Number}_]", "u");
} catch {
  gt = /[\w]/;
}
function Ne(c, i) {
  var s = c.cm6, u = "input.type.compose";
  if (c.curOp && (c.curOp.lastChange || (u = "input.type.compose.start")), i.annotations)
    try {
      i.annotations.some(function(d) {
        d.value == "input" && (d.value = u);
      });
    } catch (d) {
      console.error(d);
    }
  else
    i.userEvent = u;
  return s.dispatch(i);
}
function or(c, i) {
  var s;
  c.curOp && (c.curOp.$changeStart = void 0), (i ? Pn : Kn)(c.cm6);
  let u = (s = c.curOp) === null || s === void 0 ? void 0 : s.$changeStart;
  u != null && c.cm6.dispatch({ selection: { anchor: u } });
}
class I {
  constructor(i) {
    this.state = {}, this.marks = /* @__PURE__ */ Object.create(null), this.$mid = 0, this.options = {}, this._handlers = {}, this.doc = {
      history: {
        done: [
          {
            changes: [
              {
                cm: this,
                get to() {
                  return this.cm.posFromIndex(this.cm.$lastChangeEndOffset);
                }
              }
            ]
          }
        ]
      }
    }, this.$lastChangeEndOffset = 0, this.virtualSelection = null, this.cm6 = i, this.onChange = this.onChange.bind(this), this.onSelectionChange = this.onSelectionChange.bind(this);
  }
  static $setPlatformForTest(i) {
    i == "mac" && (pr = !0);
  }
  // --------------------------
  openDialog(i, s, u) {
    return ei(this, i, s, u);
  }
  openNotification(i, s) {
    return Zn(this, i, s);
  }
  on(i, s) {
    gr(this, i, s);
  }
  off(i, s) {
    yr(this, i, s);
  }
  signal(i, s, u) {
    mr(this, i, s, u);
  }
  indexFromPos(i) {
    return Y(this.cm6.state.doc, i);
  }
  posFromIndex(i) {
    return ie(this.cm6.state.doc, i);
  }
  foldCode(i) {
    let s = this.cm6, u = s.state.selection.ranges, d = this.cm6.state.doc, m = Y(d, i), x = ne.create([ne.range(m, m)], 0).ranges;
    s.state.selection.ranges = x, Nn(s), s.state.selection.ranges = u;
  }
  firstLine() {
    return 0;
  }
  lastLine() {
    return this.cm6.state.doc.lines - 1;
  }
  lineCount() {
    return this.cm6.state.doc.lines;
  }
  setCursor(i, s) {
    typeof i == "object" && (s = i.ch, i = i.line);
    var u = Y(this.cm6.state.doc, { line: i, ch: s });
    this.cm6.dispatch({ selection: { anchor: u } }, { scrollIntoView: !this.curOp }), this.curOp && !this.curOp.isVimOp && this.onBeforeEndOperation();
  }
  getCursor(i) {
    var s = this.cm6.state.selection.main, u = i == "head" || !i ? s.head : i == "anchor" ? s.anchor : i == "start" ? s.from : i == "end" ? s.to : null;
    if (u == null)
      throw new Error("Invalid cursor type");
    return this.posFromIndex(u);
  }
  listSelections() {
    var i = this.cm6.state.doc;
    return this.cm6.state.selection.ranges.map((s) => ({
      anchor: ie(i, s.anchor),
      head: ie(i, s.head)
    }));
  }
  setSelections(i, s) {
    var u = this.cm6.state.doc, d = i.map((m) => ne.range(Y(u, m.anchor), Y(u, m.head)));
    this.cm6.dispatch({
      selection: ne.create(d, s)
    });
  }
  setSelection(i, s, u) {
    var d = this.cm6.state.doc, m = [ne.range(Y(d, i), Y(d, s))];
    this.cm6.dispatch({
      selection: ne.create(m, 0)
    }), u && u.origin == "*mouse" && this.onBeforeEndOperation();
  }
  getLine(i) {
    var s = this.cm6.state.doc;
    return i < 0 || i >= s.lines ? "" : this.cm6.state.doc.line(i + 1).text;
  }
  getLineHandle(i) {
    return this.$lineHandleChanges || (this.$lineHandleChanges = []), { row: i, index: this.indexFromPos(new qe(i, 0)) };
  }
  getLineNumber(i) {
    var s = this.$lineHandleChanges;
    if (!s)
      return null;
    for (var u = i.index, d = 0; d < s.length; d++)
      if (u = s[d].changes.mapPos(u, 1, fr.TrackAfter), u == null)
        return null;
    var m = this.posFromIndex(u);
    return m.ch == 0 ? m.line : null;
  }
  releaseLineHandles() {
    this.$lineHandleChanges = void 0;
  }
  getRange(i, s) {
    var u = this.cm6.state.doc;
    return this.cm6.state.sliceDoc(Y(u, i), Y(u, s));
  }
  replaceRange(i, s, u) {
    u || (u = s);
    var d = this.cm6.state.doc, m = Y(d, s), x = Y(d, u);
    Ne(this, { changes: { from: m, to: x, insert: i } });
  }
  replaceSelection(i) {
    Ne(this, this.cm6.state.replaceSelection(i));
  }
  replaceSelections(i) {
    var s = this.cm6.state.selection.ranges, u = s.map((d, m) => ({ from: d.from, to: d.to, insert: i[m] || "" }));
    Ne(this, { changes: u });
  }
  getSelection() {
    return this.getSelections().join(`
`);
  }
  getSelections() {
    var i = this.cm6;
    return i.state.selection.ranges.map((s) => i.state.sliceDoc(s.from, s.to));
  }
  somethingSelected() {
    return this.cm6.state.selection.ranges.some((i) => !i.empty);
  }
  getInputField() {
    return this.cm6.contentDOM;
  }
  clipPos(i) {
    var s = this.cm6.state.doc, u = i.ch, d = i.line + 1;
    d < 1 && (d = 1, u = 0), d > s.lines && (d = s.lines, u = Number.MAX_VALUE);
    var m = s.line(d);
    return u = Math.min(Math.max(0, u), m.to - m.from), new qe(d - 1, u);
  }
  getValue() {
    return this.cm6.state.doc.toString();
  }
  setValue(i) {
    var s = this.cm6;
    return s.dispatch({
      changes: { from: 0, to: s.state.doc.length, insert: i },
      selection: ne.range(0, 0)
    });
  }
  focus() {
    return this.cm6.focus();
  }
  blur() {
    return this.cm6.contentDOM.blur();
  }
  defaultTextHeight() {
    return this.cm6.defaultLineHeight;
  }
  findMatchingBracket(i) {
    var s = this.cm6.state, u = Y(s.doc, i), d = De(s, u + 1, -1);
    return d && d.end ? { to: ie(s.doc, d.end.from) } : (d = De(s, u, 1), d && d.end ? { to: ie(s.doc, d.end.from) } : { to: void 0 });
  }
  scanForBracket(i, s, u, d) {
    return ni(this, i, s, u, d);
  }
  indentLine(i, s) {
    s ? this.indentMore() : this.indentLess();
  }
  indentMore() {
    Dn(this.cm6);
  }
  indentLess() {
    Fn(this.cm6);
  }
  execCommand(i) {
    i == "indentAuto" ? I.commands.indentAuto(this) : i == "goLineLeft" ? _n(this.cm6) : i == "goLineRight" ? (Hn(this.cm6), Vn(this.cm6)) : console.log(i + " is not implemented");
  }
  setBookmark(i, s) {
    var u = s != null && s.insertLeft ? 1 : -1, d = this.indexFromPos(i), m = new oi(this, d, u);
    return m;
  }
  addOverlay({ query: i }) {
    let s = new Qn({
      regexp: !0,
      search: i.source,
      caseSensitive: !/i/.test(i.flags)
    });
    if (s.valid) {
      s.forVim = !0, this.cm6Query = s;
      let u = pt.of(s);
      return this.cm6.dispatch({ effects: u }), s;
    }
  }
  removeOverlay(i) {
    if (!this.cm6Query)
      return;
    this.cm6Query.forVim = !1;
    let s = pt.of(this.cm6Query);
    this.cm6.dispatch({ effects: s });
  }
  getSearchCursor(i, s) {
    var u = this, d = null, m = null;
    s.ch == null && (s.ch = Number.MAX_VALUE);
    var x = Y(u.cm6.state.doc, s), L = i.source.replace(/(\\.|{(?:\d+(?:,\d*)?|,\d+)})|[{}]/g, function(E, _) {
      return _ || "\\" + E;
    });
    function T(E, _ = 0, $ = E.length) {
      return new Ct(E, L, { ignoreCase: i.ignoreCase }, _, $);
    }
    function N(E) {
      var _ = u.cm6.state.doc;
      if (E > _.length)
        return null;
      let $ = T(_, E).next();
      return $.done ? null : $.value;
    }
    var W = 1e4;
    function F(E, _) {
      var $ = u.cm6.state.doc;
      for (let pe = 1; ; pe++) {
        let xe = Math.max(E, _ - pe * W), ke = T($, xe, _), ge = null;
        for (; !ke.next().done; )
          ge = ke.value;
        if (ge && (xe == E || ge.from > xe + 10))
          return ge;
        if (xe == E)
          return null;
      }
    }
    return {
      findNext: function() {
        return this.find(!1);
      },
      findPrevious: function() {
        return this.find(!0);
      },
      find: function(E) {
        var _ = u.cm6.state.doc;
        if (E) {
          let $ = d ? d.from == d.to ? d.to - 1 : d.from : x;
          d = F(0, $);
        } else {
          let $ = d ? d.from == d.to ? d.to + 1 : d.to : x;
          d = N($);
        }
        return m = d && {
          from: ie(_, d.from),
          to: ie(_, d.to),
          match: d.match
        }, d && d.match;
      },
      from: function() {
        return m == null ? void 0 : m.from;
      },
      to: function() {
        return m == null ? void 0 : m.to;
      },
      replace: function(E) {
        d && (Ne(u, {
          changes: { from: d.from, to: d.to, insert: E }
        }), d.to = d.from + E.length, m && (m.to = ie(u.cm6.state.doc, d.to)));
      }
    };
  }
  findPosV(i, s, u, d) {
    let { cm6: m } = this;
    const x = m.state.doc;
    let L = u == "page" ? m.dom.clientHeight : 0;
    const T = Y(x, i);
    let N = ne.range(T, T, d), W = Math.round(Math.abs(s));
    for (let E = 0; E < W; E++)
      u == "page" ? N = m.moveVertically(N, s > 0, L) : u == "line" && (N = m.moveVertically(N, s > 0));
    let F = ie(x, N.head);
    return (s < 0 && N.head == 0 && d != 0 && i.line == 0 && i.ch != 0 || s > 0 && N.head == x.length && F.ch != d && i.line == F.line) && (F.hitSide = !0), F;
  }
  charCoords(i, s) {
    var u = this.cm6.contentDOM.getBoundingClientRect(), d = Y(this.cm6.state.doc, i), m = this.cm6.coordsAtPos(d), x = -u.top;
    return { left: ((m == null ? void 0 : m.left) || 0) - u.left, top: ((m == null ? void 0 : m.top) || 0) + x, bottom: ((m == null ? void 0 : m.bottom) || 0) + x };
  }
  coordsChar(i, s) {
    var u = this.cm6.contentDOM.getBoundingClientRect(), d = this.cm6.posAtCoords({ x: i.left + u.left, y: i.top + u.top }) || 0;
    return ie(this.cm6.state.doc, d);
  }
  getScrollInfo() {
    var i = this.cm6.scrollDOM;
    return {
      left: i.scrollLeft,
      top: i.scrollTop,
      height: i.scrollHeight,
      width: i.scrollWidth,
      clientHeight: i.clientHeight,
      clientWidth: i.clientWidth
    };
  }
  scrollTo(i, s) {
    i != null && (this.cm6.scrollDOM.scrollLeft = i), s != null && (this.cm6.scrollDOM.scrollTop = s);
  }
  scrollIntoView(i, s) {
    if (i) {
      var u = this.indexFromPos(i);
      this.cm6.dispatch({
        effects: yt.scrollIntoView(u)
      });
    } else
      this.cm6.dispatch({ scrollIntoView: !0, userEvent: "scroll" });
  }
  getWrapperElement() {
    return this.cm6.dom;
  }
  // for tests
  getMode() {
    return { name: this.getOption("mode") };
  }
  setSize(i, s) {
    this.cm6.dom.style.width = i + 4 + "px", this.cm6.dom.style.height = s + "px", this.refresh();
  }
  refresh() {
    this.cm6.measure();
  }
  // event listeners
  destroy() {
    this.removeOverlay();
  }
  onChange(i) {
    this.$lineHandleChanges && this.$lineHandleChanges.push(i);
    for (let u in this.marks)
      this.marks[u].update(i.changes);
    this.virtualSelection && (this.virtualSelection.ranges = this.virtualSelection.ranges.map((u) => u.map(i.changes)));
    var s = this.curOp = this.curOp || {};
    i.changes.iterChanges((u, d, m, x, L) => {
      (s.$changeStart == null || s.$changeStart > m) && (s.$changeStart = m), this.$lastChangeEndOffset = x;
      var T = { text: L.toJSON() };
      s.lastChange ? s.lastChange.next = s.lastChange = T : s.lastChange = s.change = T;
    }, !0), s.changeHandlers || (s.changeHandlers = this._handlers.change && this._handlers.change.slice());
  }
  onSelectionChange() {
    var i = this.curOp = this.curOp || {};
    i.cursorActivityHandlers || (i.cursorActivityHandlers = this._handlers.cursorActivity && this._handlers.cursorActivity.slice()), this.curOp.cursorActivity = !0;
  }
  operation(i) {
    this.curOp || (this.curOp = { $d: 0 }), this.curOp.$d++;
    try {
      var s = i();
    } finally {
      this.curOp && (this.curOp.$d--, this.curOp.$d || this.onBeforeEndOperation());
    }
    return s;
  }
  onBeforeEndOperation() {
    var i = this.curOp, s = !1;
    i && (i.change && ar(i.changeHandlers, this, i.change), i && i.cursorActivity && (ar(i.cursorActivityHandlers, this, null), i.isVimOp && (s = !0)), this.curOp = null), s && this.scrollIntoView();
  }
  moveH(i, s) {
    if (s == "char") {
      var u = this.getCursor();
      this.setCursor(u.line, u.ch + i);
    }
  }
  setOption(i, s) {
    switch (i) {
      case "keyMap":
        this.state.keyMap = s;
        break;
    }
  }
  getOption(i) {
    switch (i) {
      case "firstLineNumber":
        return 1;
      case "tabSize":
        return this.cm6.state.tabSize || 4;
      case "readonly":
        return this.cm6.state.readOnly;
      case "indentWithTabs":
        return this.cm6.state.facet(nr) == "	";
      case "indentUnit":
        return this.cm6.state.facet(nr).length || 2;
      case "keyMap":
        return this.state.keyMap || "vim";
    }
  }
  toggleOverwrite(i) {
    this.state.overwrite = i;
  }
  getTokenTypeAt(i) {
    var s, u = this.indexFromPos(i), d = Wn(this.cm6.state, u), m = d == null ? void 0 : d.resolve(u), x = ((s = m == null ? void 0 : m.type) === null || s === void 0 ? void 0 : s.name) || "";
    return /comment/i.test(x) ? "comment" : /string/i.test(x) ? "string" : "";
  }
  overWriteSelection(i) {
    var s = this.cm6.state.doc, u = this.cm6.state.selection, d = u.ranges.map((m) => {
      if (m.empty) {
        var x = m.to < s.length ? s.sliceString(m.from, m.to + 1) : "";
        if (x && !/\n/.test(x))
          return ne.range(m.from, m.to + 1);
      }
      return m;
    });
    this.cm6.dispatch({
      selection: ne.create(d, u.mainIndex)
    }), this.replaceSelection(i);
  }
  /*** multiselect ****/
  isInMultiSelectMode() {
    return this.cm6.state.selection.ranges.length > 1;
  }
  virtualSelectionMode() {
    return !!this.virtualSelection;
  }
  forEachSelection(i) {
    var s = this.cm6.state.selection;
    this.virtualSelection = ne.create(s.ranges, s.mainIndex);
    for (var u = 0; u < this.virtualSelection.ranges.length; u++) {
      var d = this.virtualSelection.ranges[u];
      d && (this.cm6.dispatch({ selection: ne.create([d]) }), i(), this.virtualSelection.ranges[u] = this.cm6.state.selection.ranges[0]);
    }
    this.cm6.dispatch({ selection: this.virtualSelection }), this.virtualSelection = null;
  }
}
I.Pos = qe;
I.StringStream = Ln;
I.commands = {
  cursorCharLeft: function(c) {
    bn(c.cm6);
  },
  redo: function(c) {
    or(c, !1);
  },
  undo: function(c) {
    or(c, !0);
  },
  newlineAndIndent: function(c) {
    An({
      state: c.cm6.state,
      dispatch: (i) => Ne(c, i)
    });
  },
  indentAuto: function(c) {
    Tn(c.cm6);
  }
};
I.defineOption = function(c, i, s) {
};
I.isWordChar = function(c) {
  return gt.test(c);
};
I.keys = {
  Backspace: function(c) {
    On(c.cm6);
  },
  Delete: function(c) {
    Rn(c.cm6);
  }
};
I.keyMap = {};
I.addClass = function() {
};
I.rmClass = function() {
};
I.e_preventDefault = function(c) {
  c.preventDefault();
};
I.e_stop = function(c) {
  var i, s;
  (i = c == null ? void 0 : c.stopPropagation) === null || i === void 0 || i.call(c), (s = c == null ? void 0 : c.preventDefault) === null || s === void 0 || s.call(c);
};
I.keyName = function(c) {
  var i = c.key;
  if (!Cr[i]) {
    i == "Escape" && (i = "Esc"), i == " " && (i = "Space"), i.length > 1 && (i = i.replace(/Numpad|Arrow/, "")), i.length == 1 && (i = i.toUpperCase());
    var s = "";
    return c.ctrlKey && (s += "Ctrl-"), c.altKey && (s += "Alt-"), (s || i.length > 1) && c.shiftKey && (s += "Shift-"), s += i, s;
  }
};
I.vimKey = function(i) {
  var s = i.key;
  if (!Cr[s]) {
    s.length > 1 && s[0] == "n" && (s = s.replace("Numpad", "")), s = Yn[s] || s;
    var u = "";
    return i.ctrlKey && (u += "C-"), i.altKey && (u += "A-"), i.metaKey && (u += "M-"), pr && i.altKey && !i.metaKey && !i.ctrlKey && (u = u.slice(2)), (u || s.length > 1) && i.shiftKey && (u += "S-"), u += s, u.length > 1 && (u = "<" + u + ">"), u;
  }
};
I.lookupKey = function(i, s, u) {
  var d = I.keys[i];
  d && u(d);
};
I.on = gr;
I.off = yr;
I.signal = mr;
I.findMatchingTag = ii;
I.findEnclosingTag = ai;
function kr(c, i, s) {
  var u = document.createElement("div");
  return u.appendChild(i), u;
}
function wr(c, i) {
  c.state.currentNotificationClose && c.state.currentNotificationClose(), c.state.currentNotificationClose = i;
}
function Zn(c, i, s) {
  wr(c, L);
  var u = kr(c, i, s && s.bottom), d = !1, m, x = s && typeof s.duration < "u" ? s.duration : 5e3;
  function L() {
    d || (d = !0, clearTimeout(m), u.remove(), xr(c, u));
  }
  return u.onclick = function(T) {
    T.preventDefault(), L();
  }, Sr(c, u), x && (m = setTimeout(L, x)), L;
}
function Sr(c, i) {
  var s = c.state.dialog;
  c.state.dialog = i, i && s !== i && (s && s.contains(document.activeElement) && c.focus(), s && s.parentElement ? s.parentElement.replaceChild(i, s) : s && s.remove(), I.signal(c, "dialog"));
}
function xr(c, i) {
  c.state.dialog == i && (c.state.dialog = null, I.signal(c, "dialog"));
}
function ei(c, i, s, u) {
  u || (u = {}), wr(c, void 0);
  var d = kr(c, i, u.bottom), m = !1;
  Sr(c, d);
  function x(T) {
    if (typeof T == "string")
      L.value = T;
    else {
      if (m)
        return;
      m = !0, xr(c, d), c.state.dialog || c.focus(), u.onClose && u.onClose(d);
    }
  }
  var L = d.getElementsByTagName("input")[0];
  return L && (u.value && (L.value = u.value, u.selectValueOnOpen !== !1 && L.select()), u.onInput && I.on(L, "input", function(T) {
    u.onInput(T, L.value, x);
  }), u.onKeyUp && I.on(L, "keyup", function(T) {
    u.onKeyUp(T, L.value, x);
  }), I.on(L, "keydown", function(T) {
    u && u.onKeyDown && u.onKeyDown(T, L.value, x) || (T.keyCode == 13 && s(L.value), (T.keyCode == 27 || u.closeOnEnter !== !1 && T.keyCode == 13) && (L.blur(), I.e_stop(T), x()));
  }), u.closeOnBlur !== !1 && I.on(L, "blur", function() {
    setTimeout(function() {
      document.activeElement !== L && x();
    });
  }), L.focus()), x;
}
var ti = { "(": ")>", ")": "(<", "[": "]>", "]": "[<", "{": "}>", "}": "{<", "<": ">>", ">": "<<" };
function ri(c) {
  return c && c.bracketRegex || /[(){}[\]]/;
}
function ni(c, i, s, u, d) {
  for (var m = d && d.maxScanLineLength || 1e4, x = d && d.maxScanLines || 1e3, L = [], T = ri(d), N = s > 0 ? Math.min(i.line + x, c.lastLine() + 1) : Math.max(c.firstLine() - 1, i.line - x), W = i.line; W != N; W += s) {
    var F = c.getLine(W);
    if (F) {
      var E = s > 0 ? 0 : F.length - 1, _ = s > 0 ? F.length : -1;
      if (!(F.length > m))
        for (W == i.line && (E = i.ch - (s < 0 ? 1 : 0)); E != _; E += s) {
          var $ = F.charAt(E);
          if (T.test($)) {
            var pe = ti[$];
            if (pe && pe.charAt(1) == ">" == s > 0)
              L.push($);
            else if (L.length)
              L.pop();
            else
              return { pos: new qe(W, E), ch: $ };
          }
        }
    }
  }
  return W - s == (s > 0 ? c.lastLine() : c.firstLine()) ? !1 : null;
}
function ii(c, i) {
  var s = c.cm6.state, u = c.indexFromPos(i), d = De(s, u + 1, -1, { brackets: `

` });
  if (d)
    return !d.end || !d.start ? void 0 : {
      open: Te(s.doc, d.end),
      close: Te(s.doc, d.start)
    };
  if (d = De(s, u, 1, { brackets: `

` }), d)
    return !d.end || !d.start ? void 0 : {
      open: Te(s.doc, d.start),
      close: Te(s.doc, d.end)
    };
}
function Te(c, i) {
  return {
    from: ie(c, i.from),
    to: ie(c, i.to)
  };
}
function ai(c, i) {
  for (var s = c.cm6.state, u = c.indexFromPos(i), d = s.sliceDoc(0, u), m = u; m > 0; ) {
    var x = De(s, m, 1, { brackets: `

` });
    if (x && x.start && x.end)
      return {
        open: Te(s.doc, x.start),
        close: Te(s.doc, x.end)
      };
    m = d.lastIndexOf(">", m - 1);
  }
}
class oi {
  constructor(i, s, u) {
    this.cm = i, this.id = i.$mid++, this.offset = s, this.assoc = u, i.marks[this.id] = this;
  }
  clear() {
    delete this.cm.marks[this.id];
  }
  find() {
    return this.offset == null ? null : this.cm.posFromIndex(this.offset);
  }
  update(i) {
    this.offset != null && (this.offset = i.mapPos(this.offset, this.assoc, fr.TrackDel));
  }
}
class si {
  constructor(i, s, u, d, m, x, L, T, N, W) {
    this.left = i, this.top = s, this.height = u, this.fontFamily = d, this.fontSize = m, this.fontWeight = x, this.color = L, this.className = T, this.letter = N, this.partial = W;
  }
  draw() {
    let i = document.createElement("div");
    return i.className = this.className, this.adjust(i), i;
  }
  adjust(i) {
    i.style.left = this.left + "px", i.style.top = this.top + "px", i.style.height = this.height + "px", i.style.lineHeight = this.height + "px", i.style.fontFamily = this.fontFamily, i.style.fontSize = this.fontSize, i.style.fontWeight = this.fontWeight, i.style.color = this.partial ? "transparent" : this.color, i.className = this.className, i.textContent = this.letter;
  }
  eq(i) {
    return this.left == i.left && this.top == i.top && this.height == i.height && this.fontFamily == i.fontFamily && this.fontSize == i.fontSize && this.fontWeight == i.fontWeight && this.color == i.color && this.className == i.className && this.letter == i.letter;
  }
}
class li {
  constructor(i, s) {
    this.view = i, this.rangePieces = [], this.cursors = [], this.cm = s, this.measureReq = { read: this.readPos.bind(this), write: this.drawSel.bind(this) }, this.cursorLayer = i.scrollDOM.appendChild(document.createElement("div")), this.cursorLayer.className = "cm-cursorLayer cm-vimCursorLayer", this.cursorLayer.setAttribute("aria-hidden", "true"), i.requestMeasure(this.measureReq), this.setBlinkRate();
  }
  setBlinkRate() {
    this.cursorLayer.style.animationDuration = 1200 + "ms";
  }
  update(i) {
    (i.selectionSet || i.geometryChanged || i.viewportChanged) && (this.view.requestMeasure(this.measureReq), this.cursorLayer.style.animationName = this.cursorLayer.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink");
  }
  scheduleRedraw() {
    this.view.requestMeasure(this.measureReq);
  }
  readPos() {
    let { state: i } = this.view, s = [];
    for (let u of i.selection.ranges) {
      let d = u == i.selection.main, m = hi(this.cm, this.view, u, d);
      m && s.push(m);
    }
    return { cursors: s };
  }
  drawSel({ cursors: i }) {
    if (i.length != this.cursors.length || i.some((s, u) => !s.eq(this.cursors[u]))) {
      let s = this.cursorLayer.children;
      if (s.length !== i.length) {
        this.cursorLayer.textContent = "";
        for (const u of i)
          this.cursorLayer.appendChild(u.draw());
      } else
        i.forEach((u, d) => u.adjust(s[d]));
      this.cursors = i;
    }
  }
  destroy() {
    this.cursorLayer.remove();
  }
}
const ui = {
  ".cm-vimMode .cm-line": {
    "& ::selection": { backgroundColor: "transparent !important" },
    "&::selection": { backgroundColor: "transparent !important" },
    caretColor: "transparent !important"
  },
  ".cm-fat-cursor": {
    position: "absolute",
    background: "#ff9696",
    border: "none",
    whiteSpace: "pre"
  },
  "&:not(.cm-focused) .cm-fat-cursor": {
    background: "none",
    outline: "solid 1px #ff9696"
  }
}, fi = /* @__PURE__ */ En.highest(/* @__PURE__ */ yt.theme(ui));
function ci(c) {
  let i = c.scrollDOM.getBoundingClientRect();
  return { left: (c.textDirection == jn.LTR ? i.left : i.right - c.scrollDOM.clientWidth) - c.scrollDOM.scrollLeft, top: i.top - c.scrollDOM.scrollTop };
}
function hi(c, i, s, u) {
  let d = s.head, m = !1, x = 1, L = c.state.vim;
  if (L && (!L.insertMode || c.state.overwrite)) {
    if (m = !0, L.visualBlock && !u)
      return null;
    s.anchor < s.head && d--, c.state.overwrite ? x = 0.2 : L.status && (x = 0.5);
  }
  if (m) {
    let T = d < i.state.doc.length && i.state.sliceDoc(d, d + 1);
    T && /[\uDC00-\uDFFF]/.test(T) && d > 1 && (d--, T = i.state.sliceDoc(d, d + 1));
    let N = i.coordsAtPos(d, 1);
    if (!N)
      return null;
    let W = ci(i), F = i.domAtPos(d), E = F ? F.node : i.contentDOM;
    for (; F && F.node instanceof HTMLElement; )
      E = F.node, F = { node: F.node.childNodes[F.offset], offset: 0 };
    if (!(E instanceof HTMLElement)) {
      if (!E.parentNode)
        return null;
      E = E.parentNode;
    }
    let _ = getComputedStyle(E);
    !T || T == `
` || T == "\r" ? T = " " : /[\uD800-\uDBFF]/.test(T) && d < i.state.doc.length - 1 && (T += i.state.sliceDoc(d + 1, d + 2));
    let $ = N.bottom - N.top;
    return new si(N.left - W.left, N.top - W.top + $ * (1 - x), $ * x, _.fontFamily, _.fontSize, _.fontWeight, _.color, u ? "cm-fat-cursor cm-cursor-primary" : "cm-fat-cursor cm-cursor-secondary", T, x != 1);
  } else
    return null;
}
const dt = /* @__PURE__ */ Xn(I), di = 250, vi = /* @__PURE__ */ yt.baseTheme({
  ".cm-vimMode .cm-cursorLayer:not(.cm-vimCursorLayer)": {
    display: "none"
  },
  ".cm-vim-panel": {
    padding: "0px 10px",
    fontFamily: "monospace",
    minHeight: "1.3em"
  },
  ".cm-vim-panel input": {
    border: "none",
    outline: "none",
    backgroundColor: "inherit"
  },
  "&light .cm-searchMatch": { backgroundColor: "#ffff0054" },
  "&dark .cm-searchMatch": { backgroundColor: "#00ffff8a" }
}), pi = /* @__PURE__ */ In.fromClass(class {
  constructor(c) {
    this.status = "", this.query = null, this.decorations = vt.none, this.lastKeydown = "", this.view = c;
    const i = this.cm = new I(c);
    dt.enterVimMode(this.cm), this.view.cm = this.cm, this.cm.state.vimPlugin = this, this.blockCursor = new li(c, i), this.updateClass(), this.cm.on("vim-command-done", () => {
      i.state.vim && (i.state.vim.status = ""), this.blockCursor.scheduleRedraw(), this.updateStatus();
    }), this.cm.on("vim-mode-change", (s) => {
      i.state.vim.mode = s.mode, s.subMode && (i.state.vim.mode += " block"), i.state.vim.status = "", this.blockCursor.scheduleRedraw(), this.updateClass(), this.updateStatus();
    }), this.cm.on("dialog", () => {
      this.cm.state.statusbar ? this.updateStatus() : c.dispatch({
        effects: Mr.of(!!this.cm.state.dialog)
      });
    }), this.dom = document.createElement("span"), this.dom.style.cssText = "position: absolute; right: 10px; top: 1px";
  }
  update(c) {
    var i;
    if ((c.viewportChanged || c.docChanged) && this.query && this.highlight(this.query), c.docChanged && this.cm.onChange(c), c.selectionSet && this.cm.onSelectionChange(), c.viewportChanged, this.cm.curOp && !this.cm.curOp.isVimOp && this.cm.onBeforeEndOperation(), c.transactions) {
      for (let s of c.transactions)
        for (let u of s.effects)
          if (u.is(pt))
            if (!((i = u.value) === null || i === void 0 ? void 0 : i.forVim))
              this.highlight(null);
            else {
              let m = u.value.create();
              this.highlight(m);
            }
    }
    this.blockCursor.update(c);
  }
  updateClass() {
    const c = this.cm.state;
    !c.vim || c.vim.insertMode && !c.overwrite ? this.view.scrollDOM.classList.remove("cm-vimMode") : this.view.scrollDOM.classList.add("cm-vimMode");
  }
  updateStatus() {
    let c = this.cm.state.statusbar, i = this.cm.state.vim;
    if (!c || !i)
      return;
    let s = this.cm.state.dialog;
    s ? s.parentElement != c && (c.textContent = "", c.appendChild(s)) : c.textContent = `--${(i.mode || "normal").toUpperCase()}--`, this.dom.textContent = i.status, c.appendChild(this.dom);
  }
  destroy() {
    dt.leaveVimMode(this.cm), this.updateClass(), this.blockCursor.destroy(), delete this.view.cm;
  }
  highlight(c) {
    if (this.query = c, !c)
      return this.decorations = vt.none;
    let { view: i } = this, s = new $n();
    for (let u = 0, d = i.visibleRanges, m = d.length; u < m; u++) {
      let { from: x, to: L } = d[u];
      for (; u < m - 1 && L > d[u + 1].from - 2 * di; )
        L = d[++u].to;
      c.highlight(i.state, x, L, (T, N) => {
        s.add(T, N, gi);
      });
    }
    return this.decorations = s.finish();
  }
  handleKey(c, i) {
    const s = I.vimKey(c), u = this.cm;
    if (!s)
      return;
    let d = u.state.vim;
    if (!d)
      return;
    if (s == "<Esc>" && !d.insertMode && !d.visualMode && this.query) {
      const x = d.searchState_;
      x && (u.removeOverlay(x.getOverlay()), x.setOverlay(null));
    }
    d.status = (d.status || "") + s;
    let m = dt.multiSelectHandleKey(u, s, "user");
    return d = u.state.vim, !m && d.insertMode && u.state.overwrite && (c.key && c.key.length == 1 && !/\n/.test(c.key) ? (m = !0, u.overWriteSelection(c.key)) : c.key == "Backspace" && (m = !0, I.commands.cursorCharLeft(u))), m && (I.signal(this.cm, "vim-keypress", s), c.preventDefault(), c.stopPropagation(), this.blockCursor.scheduleRedraw()), this.updateStatus(), !!m;
  }
}, {
  eventHandlers: {
    keypress: function(c, i) {
      this.lastKeydown == "Dead" && this.handleKey(c, i);
    },
    keydown: function(c, i) {
      this.lastKeydown = c.key, this.handleKey(c, i);
    }
  },
  decorations: (c) => c.decorations
}), gi = /* @__PURE__ */ vt.mark({ class: "cm-searchMatch" }), Mr = /* @__PURE__ */ sr.define(), yi = /* @__PURE__ */ Bn.define({
  create: () => !1,
  update(c, i) {
    for (let s of i.effects)
      s.is(Mr) && (c = s.value);
    return c;
  },
  provide: (c) => ur.from(c, (i) => i ? mi : null)
});
function mi(c) {
  let i = document.createElement("div");
  i.className = "cm-vim-panel";
  let s = c.cm;
  return s.state.dialog && i.appendChild(s.state.dialog), { top: !1, dom: i };
}
function Ci(c) {
  let i = document.createElement("div");
  i.className = "cm-vim-panel";
  let s = c.cm;
  return s.state.statusbar = i, s.state.vimPlugin.updateStatus(), { dom: i };
}
function wi(c = {}) {
  return [
    vi,
    pi,
    fi,
    c.status ? ur.of(Ci) : yi
  ];
}
export {
  wi as vim
};
